// Coselica Toolbox for Scicos/Nsp
// Copyright (C) 2009-2016  Dirk Reusch, Kybernetik Dr. Reusch
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

function [x,y,typ]=CBM_Add(job,arg1,arg2)

  function blk_draw(sz,orig,orient,label)
    if orient then
      xx=orig(1);yy=orig(2);
      ww=sz(1);hh=sz(2);
    else
      xx=orig(1)+sz(1);yy=orig(2);
      ww=-sz(1);hh=sz(2);
    end
    if orient then
      xrect(orig(1)+sz(1)*0,orig(2)+sz(2)*1,sz(1)*1,sz(2)*1,color=color(0,0,127),background=color(255,255,255),thickness=0.25);
    else
      xrect(orig(1)+sz(1)*(1-0-1),orig(2)+sz(2)*1,sz(1)*1,sz(2)*1,color=color(0,0,127),background=color(255,255,255),thickness=0.25);
    end
    if orient then
      xstring(orig(1)+sz(1)*-0.25,orig(2)+sz(2)*1.05,model.label,w=sz(1)*1.5,h=sz(2)*0.2,fill=%t,color=color(0,0,0));
    else
      xstring(orig(1)+sz(1)*(-0.25),orig(2)+sz(2)*1.05,model.label,w=sz(1)*1.5,h=sz(2)*0.2,fill=%t,color=color(0,0,0));
    end
    if orient then
      xstring(orig(1)+sz(1)*0.01,orig(2)+sz(2)*0.04,""+string(k2)+"",w=sz(1)*0.525,h=sz(2)*0.2,fill=%t,color=color(0,0,0));
    else
      xstring(orig(1)+sz(1)*(0.465),orig(2)+sz(2)*0.04,""+string(k2)+"",w=sz(1)*0.525,h=sz(2)*0.2,fill=%t,color=color(0,0,0));
    end
    if orient then
      xstring(orig(1)+sz(1)*0,orig(2)+sz(2)*0.75,""+string(k1)+"",w=sz(1)*0.525,h=sz(2)*0.2,fill=%t,color=color(0,0,0));
    else
      xstring(orig(1)+sz(1)*(0.475),orig(2)+sz(2)*0.75,""+string(k1)+"",w=sz(1)*0.525,h=sz(2)*0.2,fill=%t,color=color(0,0,0));
    end
    if orient then
      xstring(orig(1)+sz(1)*-0.25,orig(2)+sz(2)*1.05,model.label,w=sz(1)*1.5,h=sz(2)*0.2,fill=%t,color=color(0,0,0));
    else
      xstring(orig(1)+sz(1)*(-0.25),orig(2)+sz(2)*1.05,model.label,w=sz(1)*1.5,h=sz(2)*0.2,fill=%t,color=color(0,0,0));
    end
    xpoly(xx+ww*[0;0.3;0.35],yy+hh*[0.8;0.8;0.7],color=color(0,0,0),thickness=0.25);
    if orient then
      xarc(orig(1)+sz(1)*0.25,orig(2)+sz(2)*0.75,sz(1)*0.5,sz(2)*0.5,0,23040,color=color(0,0,0),thickness=0.25);
    else
      xarc(orig(1)+sz(1)*(1-0.25-0.5),orig(2)+sz(2)*0.75,sz(1)*0.5,sz(2)*0.5,-11520,23040,color=color(0,0,0),thickness=0.25);
    end
    xpoly(xx+ww*[0;0.3;0.35],yy+hh*[0.2;0.2;0.3],color=color(0,0,0),thickness=0.25);
    xpoly(xx+ww*[0.425;0.575],yy+hh*[0.37005;0.62995],color=color(0,0,0),thickness=0.25);
    if orient then
      xrect(orig(1)+sz(1)*0,orig(2)+sz(2)*1,sz(1)*1,sz(2)*1,color=color(0,0,191),background=color(255,255,255),thickness=0.25);
    else
      xrect(orig(1)+sz(1)*(1-0-1),orig(2)+sz(2)*1,sz(1)*1,sz(2)*1,color=color(0,0,191),background=color(255,255,255),thickness=0.25);
    end
    xpoly(xx+ww*[0.75;1],yy+hh*[0.5;0.5],color=color(0,0,0),thickness=0.25);
    xpoly(xx+ww*[0;0.13;0.28],yy+hh*[0.8;0.62;0.62],color=color(0,0,191),thickness=0.25);
    xpoly(xx+ww*[0;0.13;0.29],yy+hh*[0.2;0.36;0.36],color=color(0,0,191),thickness=0.25);
    if orient then
      xarc(orig(1)+sz(1)*0.25,orig(2)+sz(2)*0.75,sz(1)*0.5,sz(2)*0.5,0,23040,color=color(0,0,191),thickness=0.25);
    else
      xarc(orig(1)+sz(1)*(1-0.25-0.5),orig(2)+sz(2)*0.75,sz(1)*0.5,sz(2)*0.5,-11520,23040,color=color(0,0,191),thickness=0.25);
    end
    xpoly(xx+ww*[0.75;1],yy+hh*[0.5;0.5],color=color(0,0,191),thickness=0.25);
    if orient then
      xstring(orig(1)+sz(1)*0.31,orig(2)+sz(2)*0.33,"+",w=sz(1)*0.38,h=sz(2)*0.34,fill=%t,color=color(0,0,0));
    else
      xstring(orig(1)+sz(1)*(0.31),orig(2)+sz(2)*0.33,"+",w=sz(1)*0.38,h=sz(2)*0.34,fill=%t,color=color(0,0,0));
    end
    if orient then
      xstring(orig(1)+sz(1)*0,orig(2)+sz(2)*0.76,""+string(k1)+"",w=sz(1)*0.525,h=sz(2)*0.2,fill=%t,color=color(0,0,0));
    else
      xstring(orig(1)+sz(1)*(0.475),orig(2)+sz(2)*0.76,""+string(k1)+"",w=sz(1)*0.525,h=sz(2)*0.2,fill=%t,color=color(0,0,0));
    end
    if orient then
      xstring(orig(1)+sz(1)*0,orig(2)+sz(2)*0.04,""+string(k2)+"",w=sz(1)*0.525,h=sz(2)*0.2,fill=%t,color=color(0,0,0));
    else
      xstring(orig(1)+sz(1)*(0.475),orig(2)+sz(2)*0.04,""+string(k2)+"",w=sz(1)*0.525,h=sz(2)*0.2,fill=%t,color=color(0,0,0));
    end
  endfunction

x=[];y=[];typ=[];

select job
  case 'plot' then
    k1=arg1.graphics.exprs(1);
    k2=arg1.graphics.exprs(2);
    standard_draw(arg1,%f,_MBI_SI2SO_dp);
  case 'getinputs' then
    [x,y,typ]=_MBI_SI2SO_ip(arg1);
  case 'getoutputs' then
    [x,y,typ]=_MBI_SI2SO_op(arg1);
  case 'getorigin' then
    [x,y]=standard_origin(arg1);
  case 'set' then
    x=arg1;
    graphics=arg1.graphics;exprs=graphics.exprs;
    model=arg1.model;
    while %t do
      [ok,k1,k2,exprs]=..
        getvalue(['';'CBM_Add';'';'Output the sum of the two inputs';''],..
        [' k1 [-] : Gain of upper input',' k2 [-] : Gain of lower input'],..
        list('vec',1,'vec',1),exprs);
      if ~ok then break, end
      model.equations.parameters(2)=list(k1,k2)
      model.in=[1;1];
      model.out=[1];
      graphics.exprs=exprs;
      x.graphics=graphics;x.model=model;
      break
    end
  case 'define' then
    k1=1;
    k2=1;
    model=scicos_model();
    model.sim='Coselica';
    model.blocktype='c';
    model.dep_ut=[%t %f];
    model.in=[1;1];
    model.out=[1];
    mo=modelica();
      mo.model='Coselica.Blocks.Math.Add';
      mo.inputs=['u1','u2'];
      mo.outputs=['y'];
      mo.parameters=list(['k1','k2'],..
                         list(k1,k2),..
                         [0,0]);
    model.equations=mo;
    exprs=[strcat(sci2exp(k1));strcat(sci2exp(k2))];
    gr_i="blk_draw(sz,orig,orient,model.label)";
    x=standard_define([2 2],model,exprs,list(gr_i,0));
    x.graphics.in_implicit=['E','E'];
    x.graphics.out_implicit=['E'];
  end
endfunction
