// Coselica Toolbox for Scicos/Nsp
// Copyright (C) 2009-2016  Dirk Reusch, Kybernetik Dr. Reusch
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

function [x,y,typ]=CBM_Cosh(job,arg1,arg2)

  function blk_draw(sz,orig,orient,label)
    if orient then
      xx=orig(1);yy=orig(2);
      ww=sz(1);hh=sz(2);
    else
      xx=orig(1)+sz(1);yy=orig(2);
      ww=-sz(1);hh=sz(2);
    end
    if orient then
      xrect(orig(1)+sz(1)*0,orig(2)+sz(2)*1,sz(1)*1,sz(2)*1,color=color(0,0,127),background=color(255,255,255),thickness=0.25);
    else
      xrect(orig(1)+sz(1)*(1-0-1),orig(2)+sz(2)*1,sz(1)*1,sz(2)*1,color=color(0,0,127),background=color(255,255,255),thickness=0.25);
    end
    if orient then
      xstring(orig(1)+sz(1)*-0.25,orig(2)+sz(2)*1.05,model.label,w=sz(1)*1.5,h=sz(2)*0.2,fill=%t,color=color(0,0,0));
    else
      xstring(orig(1)+sz(1)*(-0.25),orig(2)+sz(2)*1.05,model.label,w=sz(1)*1.5,h=sz(2)*0.2,fill=%t,color=color(0,0,0));
    end
    xfpoly(xx+ww*[0.5;0.46;0.54;0.5],yy+hh*[0.95;0.84;0.84;0.95],color=color(192,192,192),fill_color=color(192,192,192),thickness=0.25);
    xpoly(xx+ww*[0.5;0.5],yy+hh*[0.1;0.84],color=color(192,192,192),thickness=0.25);
    if orient then
      xstring(orig(1)+sz(1)*0.52,orig(2)+sz(2)*0.6,"cosh",w=sz(1)*0.31,h=sz(2)*0.23,fill=%t,color=color(0,0,0));
    else
      xstring(orig(1)+sz(1)*(0.17),orig(2)+sz(2)*0.6,"cosh",w=sz(1)*0.31,h=sz(2)*0.23,fill=%t,color=color(0,0,0));
    end
    xpoly(xx+ww*[0.1;0.112;0.128;0.144;0.1645;0.1845;0.2085;0.2365;0.269;0.305;0.349;0.4055;0.4779;0.5545;0.6185;0.671;0.711;0.743;0.7715;0.7955;0.8155;0.8355;0.856;0.872;0.888;0.9],yy+hh*[0.9;0.8055;0.6965;0.6035;0.50645;0.427;0.351;0.2825;0.2245;0.1785;0.1415;0.1145;0.1005;0.1045;0.124;0.1565;0.197;0.244;0.3;0.3625;0.427;0.50645;0.6035;0.6965;0.8055;0.9],color=color(0,0,0),thickness=0.25);
    xpoly(xx+ww*[0.05;0.84],yy+hh*[0.0696;0.0696],color=color(192,192,192),thickness=0.25);
    xfpoly(xx+ww*[0.95;0.84;0.84;0.95],yy+hh*[0.0696;0.1096;0.0296;0.0696],color=color(192,192,192),fill_color=color(192,192,192),thickness=0.25);
  endfunction

x=[];y=[];typ=[];

select job
  case 'plot' then
    standard_draw(arg1,%f,_MBI_SISO_dp);
  case 'getinputs' then
    [x,y,typ]=_MBI_SISO_ip(arg1);
  case 'getoutputs' then
    [x,y,typ]=_MBI_SISO_op(arg1);
  case 'getorigin' then
    [x,y]=standard_origin(arg1);
  case 'set' then
    x=arg1;
  case 'define' then
    model=scicos_model();
    model.sim='Coselica';
    model.blocktype='c';
    model.dep_ut=[%t %f];
    model.in=[1];
    model.out=[1];
    mo=modelica();
      mo.model='Coselica.Blocks.Math.Cosh';
      mo.inputs=['u'];
      mo.outputs=['y'];
      mo.parameters=list([],list(),[]);
    model.equations=mo;
    exprs=[];
    gr_i="blk_draw(sz,orig,orient,model.label)";
    x=standard_define([2 2],model,exprs,list(gr_i,0));
    x.graphics.in_implicit=['E'];
    x.graphics.out_implicit=['E'];
  end
endfunction
