// Coselica Toolbox for Scicos/Nsp
// Copyright (C) 2009-2016  Dirk Reusch, Kybernetik Dr. Reusch
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

function [x,y,typ]=CBM_Feedback(job,arg1,arg2)

  function blk_draw(sz,orig,orient,label)
    if orient then
      xx=orig(1);yy=orig(2);
      ww=sz(1);hh=sz(2);
    else
      xx=orig(1)+sz(1);yy=orig(2);
      ww=-sz(1);hh=sz(2);
    end
    if orient then
      xarc(orig(1)+sz(1)*0.4,orig(2)+sz(2)*0.6,sz(1)*0.2,sz(2)*0.2,0,23040,color=color(0,0,191),background=color(235,235,235),thickness=0.25);
    else
      xarc(orig(1)+sz(1)*(1-0.4-0.2),orig(2)+sz(2)*0.6,sz(1)*0.2,sz(2)*0.2,-11520,23040,color=color(0,0,191),background=color(235,235,235),thickness=0.25);
    end
    xpoly(xx+ww*[0;0.4],yy+hh*[0.5;0.5],color=color(0,0,191),thickness=0.25);
    xpoly(xx+ww*[0.6;1],yy+hh*[0.5;0.5],color=color(0,0,191),thickness=0.25);
    xpoly(xx+ww*[0.5;0.5],yy+hh*[0.4;0],color=color(0,0,191),thickness=0.25);
    if orient then
      xstring(orig(1)+sz(1)*0.43,orig(2)+sz(2)*0.03,"-",w=sz(1)*0.48,h=sz(2)*0.47,fill=%t,color=color(0,0,0));
    else
      xstring(orig(1)+sz(1)*(0.09),orig(2)+sz(2)*0.03,"-",w=sz(1)*0.48,h=sz(2)*0.47,fill=%t,color=color(0,0,0));
    end
    if orient then
      xstring(orig(1)+sz(1)*0,orig(2)+sz(2)*0.8,model.label,w=sz(1)*1,h=sz(2)*0.25,fill=%t,color=color(0,0,0));
    else
      xstring(orig(1)+sz(1)*(0),orig(2)+sz(2)*0.8,model.label,w=sz(1)*1,h=sz(2)*0.25,fill=%t,color=color(0,0,0));
    end
  endfunction

x=[];y=[];typ=[];

select job
  case 'plot' then
    standard_draw(arg1,%f,_CBM_Feedback_dp);
  case 'getinputs' then
    [x,y,typ]=_CBM_Feedback_ip(arg1);
  case 'getoutputs' then
    [x,y,typ]=_CBM_Feedback_op(arg1);
  case 'getorigin' then
    [x,y]=standard_origin(arg1);
  case 'set' then
    x=arg1;
  case 'define' then
    model=scicos_model();
    model.sim='Coselica';
    model.blocktype='c';
    model.dep_ut=[%t %f];
    model.in=[1;1];
    model.out=[1];
    mo=modelica();
      mo.model='Coselica.Blocks.Math.Feedback';
      mo.inputs=['u1','u2'];
      mo.outputs=['y'];
      mo.parameters=list([],list(),[]);
    model.equations=mo;
    exprs=[];
    gr_i="blk_draw(sz,orig,orient,model.label)";
    x=standard_define([2 2],model,exprs,list(gr_i,0));
    x.graphics.in_implicit=['E','E'];
    x.graphics.out_implicit=['E'];
  end
endfunction
