// Coselica Toolbox for Scicos/Nsp
// Copyright (C) 2009-2016  Dirk Reusch, Kybernetik Dr. Reusch
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

function [x,y,typ]=CBS_Clock(job,arg1,arg2)

  function blk_draw(sz,orig,orient,label)
    if orient then
      xx=orig(1);yy=orig(2);
      ww=sz(1);hh=sz(2);
    else
      xx=orig(1)+sz(1);yy=orig(2);
      ww=-sz(1);hh=sz(2);
    end
    if orient then
      xrect(orig(1)+sz(1)*0,orig(2)+sz(2)*1,sz(1)*1,sz(2)*1,color=color(0,0,127),background=color(255,255,255),thickness=0.25);
    else
      xrect(orig(1)+sz(1)*(1-0-1),orig(2)+sz(2)*1,sz(1)*1,sz(2)*1,color=color(0,0,127),background=color(255,255,255),thickness=0.25);
    end
    if orient then
      xstring(orig(1)+sz(1)*-0.25,orig(2)+sz(2)*1.05,model.label,w=sz(1)*1.5,h=sz(2)*0.2,fill=%t,color=color(0,0,0));
    else
      xstring(orig(1)+sz(1)*(-0.25),orig(2)+sz(2)*1.05,model.label,w=sz(1)*1.5,h=sz(2)*0.2,fill=%t,color=color(0,0,0));
    end
    if orient then
      xarc(orig(1)+sz(1)*0.1,orig(2)+sz(2)*0.9,sz(1)*0.8,sz(2)*0.8,0,23040,color=color(160,160,160),thickness=0.25);
    else
      xarc(orig(1)+sz(1)*(1-0.1-0.8),orig(2)+sz(2)*0.9,sz(1)*0.8,sz(2)*0.8,11520,-23040,color=color(160,160,160),thickness=0.25);
    end
    xpoly(xx+ww*[0.5;0.5],yy+hh*[0.9;0.8],color=color(160,160,160),thickness=0.25);
    xpoly(xx+ww*[0.9;0.8],yy+hh*[0.5;0.5],color=color(160,160,160),thickness=0.25);
    xpoly(xx+ww*[0.5;0.5],yy+hh*[0.1;0.2],color=color(160,160,160),thickness=0.25);
    xpoly(xx+ww*[0.1;0.2],yy+hh*[0.5;0.5],color=color(160,160,160),thickness=0.25);
    xpoly(xx+ww*[0.685;0.63],yy+hh*[0.85;0.75],color=color(160,160,160),thickness=0.25);
    xpoly(xx+ww*[0.85;0.745],yy+hh*[0.69;0.63],color=color(160,160,160),thickness=0.25);
    xpoly(xx+ww*[0.855;0.76],yy+hh*[0.315;0.365],color=color(160,160,160),thickness=0.25);
    xpoly(xx+ww*[0.695;0.645],yy+hh*[0.15;0.245],color=color(160,160,160),thickness=0.25);
    xpoly(xx+ww*[0.305;0.355],yy+hh*[0.15;0.24],color=color(160,160,160),thickness=0.25);
    xpoly(xx+ww*[0.145;0.25],yy+hh*[0.315;0.37],color=color(160,160,160),thickness=0.25);
    xpoly(xx+ww*[0.145;0.23],yy+hh*[0.685;0.64],color=color(160,160,160),thickness=0.25);
    xpoly(xx+ww*[0.31;0.36],yy+hh*[0.85;0.755],color=color(160,160,160),thickness=0.25);
    xpoly(xx+ww*[0.5;0.25],yy+hh*[0.5;0.75],color=color(0,0,0),thickness=0.5);
    xpoly(xx+ww*[0.5;0.7],yy+hh*[0.5;0.5],color=color(0,0,0),thickness=0.5);
    if orient then
      xstring(orig(1)+sz(1)*-0.25,orig(2)+sz(2)*-0.25,"startTime="+string(startTime)+"",w=sz(1)*1.5,h=sz(2)*0.2,fill=%t,color=color(0,0,0));
    else
      xstring(orig(1)+sz(1)*(-0.25),orig(2)+sz(2)*-0.25,"startTime="+string(startTime)+"",w=sz(1)*1.5,h=sz(2)*0.2,fill=%t,color=color(0,0,0));
    end
  endfunction

x=[];y=[];typ=[];

select job
  case 'plot' then
    offset=arg1.graphics.exprs(1);
    startTime=arg1.graphics.exprs(2);
    standard_draw(arg1,%f,_MBI_SO_dp);
  case 'getinputs' then
    [x,y,typ]=_MBI_SO_ip(arg1);
  case 'getoutputs' then
    [x,y,typ]=_MBI_SO_op(arg1);
  case 'getorigin' then
    [x,y]=standard_origin(arg1);
  case 'set' then
    x=arg1;
    graphics=arg1.graphics;exprs=graphics.exprs;
    model=arg1.model;
    while %t do
      [ok,offset,startTime,exprs]=..
        getvalue(['';'CBS_Clock';'';'Generate actual time signal';''],..
        [' offset [-] : Offset of output signal',' startTime [s] : Output = offset for time < startTime'],..
        list('vec',1,'vec',1),exprs);
      if ~ok then break, end
      model.equations.parameters(2)=list(offset,startTime)
      model.in=[];
      model.out=[1];
      graphics.exprs=exprs;
      x.graphics=graphics;x.model=model;
      break
    end
  case 'define' then
    offset=0;
    startTime=0;
    model=scicos_model();
    model.sim='Coselica';
    model.blocktype='c';
    model.dep_ut=[%t %f];
    model.in=[];
    model.out=[1];
    mo=modelica();
      mo.model='Coselica.Blocks.Sources.Clock';
      mo.inputs=[];
      mo.outputs=['y'];
      mo.parameters=list(['offset','startTime'],..
                         list(offset,startTime),..
                         [0,0]);
    model.equations=mo;
    exprs=[strcat(sci2exp(offset));strcat(sci2exp(startTime))];
    gr_i="blk_draw(sz,orig,orient,model.label)";
    x=standard_define([2 2],model,exprs,list(gr_i,0));
    x.graphics.in_implicit=[];
    x.graphics.out_implicit=['E'];
  end
endfunction
