// Coselica Toolbox for Scicos/Nsp
// Copyright (C) 2009-2016  Dirk Reusch, Kybernetik Dr. Reusch
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

function [x,y,typ]=CEAB_CCV(job,arg1,arg2)

  function blk_draw(sz,orig,orient,label)
    if orient then
      xx=orig(1);yy=orig(2);
      ww=sz(1);hh=sz(2);
    else
      xx=orig(1)+sz(1);yy=orig(2);
      ww=-sz(1);hh=sz(2);
    end
    if orient then
      xrect(orig(1)+sz(1)*0.15,orig(2)+sz(2)*0.85,sz(1)*0.7,sz(2)*0.7,color=color(0,0,255),background=color(255,255,255),thickness=0.25);
    else
      xrect(orig(1)+sz(1)*(1-0.15-0.7),orig(2)+sz(2)*0.85,sz(1)*0.7,sz(2)*0.7,color=color(0,0,255),background=color(255,255,255),thickness=0.25);
    end
    if orient then
      xstring(orig(1)+sz(1)*0.005,orig(2)+sz(2)*-0.15,model.label,w=sz(1)*0.995,h=sz(2)*0.25,fill=%t,color=color(0,0,0));
    else
      xstring(orig(1)+sz(1)*(0),orig(2)+sz(2)*-0.15,model.label,w=sz(1)*0.995,h=sz(2)*0.25,fill=%t,color=color(0,0,0));
    end
    xpoly(xx+ww*[0.95;0.65;0.65;0.95],yy+hh*[0.75;0.75;0.25;0.25],color=color(0,0,255),thickness=0.25);
    if orient then
      xarc(orig(1)+sz(1)*0.55,orig(2)+sz(2)*0.6,sz(1)*0.2,sz(2)*0.2,0,23040,color=color(0,0,255),thickness=0.25);
    else
      xarc(orig(1)+sz(1)*(1-0.55-0.2),orig(2)+sz(2)*0.6,sz(1)*0.2,sz(2)*0.2,-11520,23040,color=color(0,0,255),thickness=0.25);
    end
    xpoly(xx+ww*[0.4;0.6],yy+hh*[0.8;0.8],color=color(0,0,255),thickness=0.25);
    xfpoly(xx+ww*[0.6;0.55;0.55;0.6],yy+hh*[0.8;0.815;0.785;0.8],color=color(0,0,255),fill_color=color(0,0,255),thickness=0.25);
    xpoly(xx+ww*[0.05;0.4;0.4;0.05],yy+hh*[0.75;0.75;0.25;0.25],color=color(0,0,255),thickness=0.25);
  endfunction

x=[];y=[];typ=[];

select job
  case 'plot' then
    transResistance=arg1.graphics.exprs(1);
    standard_draw(arg1,%f,_MEAI_TwoPort_dp);
  case 'getinputs' then
    [x,y,typ]=_MEAI_TwoPort_ip(arg1);
  case 'getoutputs' then
    [x,y,typ]=_MEAI_TwoPort_op(arg1);
  case 'getorigin' then
    [x,y]=standard_origin(arg1);
  case 'set' then
    x=arg1;
    graphics=arg1.graphics;exprs=graphics.exprs;
    model=arg1.model;
    while %t do
      [ok,transResistance,exprs]=..
        getvalue(['';'CEAB_CCV';'';'Linear current-controlled voltage source';''],..
        [' transResistance [Ohm] : Transresistance'],..
        list('vec',1),exprs);
      if ~ok then break, end
      model.equations.parameters(2)=list(transResistance)
      model.in=[1;1];
      model.out=[1;1];
      graphics.exprs=exprs;
      x.graphics=graphics;x.model=model;
      break
    end
  case 'define' then
    transResistance=1;
    model=scicos_model();
    model.sim='Coselica';
    model.blocktype='c';
    model.dep_ut=[%t %f];
    model.in=[1;1];
    model.out=[1;1];
    mo=modelica();
      mo.model='Coselica.Electrical.Analog.Basic.CCV';
      mo.inputs=['p1','n1'];
      mo.outputs=['p2','n2'];
      mo.parameters=list(['transResistance'],..
                         list(transResistance),..
                         [0]);
    model.equations=mo;
    exprs=[strcat(sci2exp(transResistance))];
    gr_i="blk_draw(sz,orig,orient,model.label)";
    x=standard_define([2 2],model,exprs,list(gr_i,0));
    x.graphics.in_implicit=['I','I'];
    x.graphics.out_implicit=['I','I'];
  end
endfunction
