// Coselica Toolbox for Scicos/Nsp
// Copyright (C) 2009-2016  Dirk Reusch, Kybernetik Dr. Reusch
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

function [x,y,typ]=CEAB_OpAmp(job,arg1,arg2)

  function blk_draw(sz,orig,orient,label)
    if orient then
      xx=orig(1);yy=orig(2);
      ww=sz(1);hh=sz(2);
    else
      xx=orig(1)+sz(1);yy=orig(2);
      ww=-sz(1);hh=sz(2);
    end
    if orient then
      xstring(orig(1)+sz(1)*0.025,orig(2)+sz(2)*0.94,model.label,w=sz(1)*1.05,h=sz(2)*0.29,fill=%t,color=color(0,0,0));
    else
      xstring(orig(1)+sz(1)*(-0.075),orig(2)+sz(2)*0.94,model.label,w=sz(1)*1.05,h=sz(2)*0.29,fill=%t,color=color(0,0,0));
    end
    xfpoly(xx+ww*[0.8;0.2;0.2;0.8],yy+hh*[0.5;0.85;0.15;0.5],color=color(0,0,255),fill_color=color(255,255,255),thickness=0.25);
    xpoly(xx+ww*[0.275;0.4;0.43;0.445;0.455;0.47;0.5;0.6],yy+hh*[0.45;0.45;0.455;0.465;0.535;0.545;0.55;0.55],color=color(0,0,255),thickness=0.25);
    xpoly(xx+ww*[0.5;0.5],yy+hh*[0.675;0.95],color=color(0,0,255),thickness=0.25);
    xpoly(xx+ww*[0.5;0.5],yy+hh*[0.325;0.05],color=color(0,0,255),thickness=0.25);
    xpoly(xx+ww*[0.05;0.2],yy+hh*[0.75;0.75],color=color(0,0,255),thickness=0.25);
    xpoly(xx+ww*[0.05;0.2],yy+hh*[0.25;0.25],color=color(0,0,255),thickness=0.25);
    xpoly(xx+ww*[0.8;0.95],yy+hh*[0.5;0.5],color=color(0,0,255),thickness=0.25);
    xpoly(xx+ww*[0.26;0.36],yy+hh*[0.66;0.66],color=color(0,0,255),thickness=0.25);
    xpoly(xx+ww*[0.305;0.305],yy+hh*[0.4;0.295],color=color(0,0,255),thickness=0.25);
    xpoly(xx+ww*[0.25;0.36],yy+hh*[0.345;0.345],color=color(0,0,255),thickness=0.25);
  endfunction

x=[];y=[];typ=[];

select job
  case 'plot' then
    Slope=arg1.graphics.exprs(1);
    standard_draw(arg1,%f,_CEAB_OpAmp_dp);
  case 'getinputs' then
    [x,y,typ]=_CEAB_OpAmp_ip(arg1);
  case 'getoutputs' then
    [x,y,typ]=_CEAB_OpAmp_op(arg1);
  case 'getorigin' then
    [x,y]=standard_origin(arg1);
  case 'set' then
    x=arg1;
    graphics=arg1.graphics;exprs=graphics.exprs;
    model=arg1.model;
    while %t do
      [ok,Slope,exprs]=..
        getvalue(['';'CEAB_OpAmp';'';'Simple nonideal model of an OpAmp with limitation';''],..
        [' Slope [-] : Slope of the out.v/vin characteristic at vin=0'],..
        list('vec',1),exprs);
      if ~ok then break, end
      model.equations.parameters(2)=list(Slope)
      model.in=[1;1;1];
      model.out=[1;1];
      graphics.exprs=exprs;
      x.graphics=graphics;x.model=model;
      break
    end
  case 'define' then
    Slope=1;
    model=scicos_model();
    model.sim='Coselica';
    model.blocktype='c';
    model.dep_ut=[%t %f];
    model.in=[1;1;1];
    model.out=[1;1];
    mo=modelica();
      mo.model='Coselica.Electrical.Analog.Basic.OpAmp';
      mo.inputs=['in_n','in_p','VMax'];
      mo.outputs=['out','VMin'];
      mo.parameters=list(['Slope'],..
                         list(Slope),..
                         [0]);
    model.equations=mo;
    exprs=[strcat(sci2exp(Slope))];
    gr_i="blk_draw(sz,orig,orient,model.label)";
    x=standard_define([2 2],model,exprs,list(gr_i,0));
    x.graphics.in_implicit=['I','I','I'];
    x.graphics.out_implicit=['I','I'];
  end
endfunction
