// Coselica Toolbox for Scicos/Nsp
// Copyright (C) 2009-2016  Dirk Reusch, Kybernetik Dr. Reusch
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

function [x,y,typ]=CEAB_TranslationalEMF(job,arg1,arg2)

  function blk_draw(sz,orig,orient,label)
    if orient then
      xx=orig(1);yy=orig(2);
      ww=sz(1);hh=sz(2);
    else
      xx=orig(1)+sz(1);yy=orig(2);
      ww=-sz(1);hh=sz(2);
    end
    if orient then
      xrect(orig(1)+sz(1)*0.05,orig(2)+sz(2)*0.755,sz(1)*0.25,sz(2)*0.505,color=color(135,135,135),background=color(135,135,135),thickness=0.25);
    else
      xrect(orig(1)+sz(1)*(1-0.05-0.25),orig(2)+sz(2)*0.755,sz(1)*0.25,sz(2)*0.505,color=color(135,135,135),background=color(135,135,135),thickness=0.25);
    end
    if orient then
      xrect(orig(1)+sz(1)*0.395,orig(2)+sz(2)*0.6,sz(1)*0.555,sz(2)*0.2,color=color(135,135,135),background=color(135,135,135),thickness=0.25);
    else
      xrect(orig(1)+sz(1)*(1-0.395-0.555),orig(2)+sz(2)*0.6,sz(1)*0.555,sz(2)*0.2,color=color(135,135,135),background=color(135,135,135),thickness=0.25);
    end
    if orient then
      xstring(orig(1)+sz(1)*0.5,orig(2)+sz(2)*0.72,"k="+string(k)+"",w=sz(1)*0.74,h=sz(2)*0.18,fill=%t,color=color(0,0,0));
    else
      xstring(orig(1)+sz(1)*(-0.24),orig(2)+sz(2)*0.72,"k="+string(k)+"",w=sz(1)*0.74,h=sz(2)*0.18,fill=%t,color=color(0,0,0));
    end
    xpoly(xx+ww*[0.35;0.35;0.5;0.5],yy+hh*[0.745;0.9;0.9;0.95],color=color(0,0,255),thickness=0.25);
    xpoly(xx+ww*[0.6;0.6;0.5;0.5],yy+hh*[0.255;0.1;0.1;0.05],color=color(0,0,255),thickness=0.25);
    if orient then
      xarc(orig(1)+sz(1)*0.395,orig(2)+sz(2)*0.75,sz(1)*0.15,sz(2)*0.5,0,23040,color=color(0,0,255),thickness=0.25);
    else
      xarc(orig(1)+sz(1)*(1-0.395-0.15),orig(2)+sz(2)*0.75,sz(1)*0.15,sz(2)*0.5,-11520,23040,color=color(0,0,255),thickness=0.25);
    end
    if orient then
      xarc(orig(1)+sz(1)*0.51,orig(2)+sz(2)*0.75,sz(1)*0.15,sz(2)*0.5,0,23040,color=color(0,0,255),thickness=0.25);
    else
      xarc(orig(1)+sz(1)*(1-0.51-0.15),orig(2)+sz(2)*0.75,sz(1)*0.15,sz(2)*0.5,-11520,23040,color=color(0,0,255),thickness=0.25);
    end
    if orient then
      xarc(orig(1)+sz(1)*0.285,orig(2)+sz(2)*0.75,sz(1)*0.15,sz(2)*0.5,0,23040,color=color(0,0,255),thickness=0.25);
    else
      xarc(orig(1)+sz(1)*(1-0.285-0.15),orig(2)+sz(2)*0.75,sz(1)*0.15,sz(2)*0.5,-11520,23040,color=color(0,0,255),thickness=0.25);
    end
    if orient then
      xrect(orig(1)+sz(1)*0.48,orig(2)+sz(2)*0.6,sz(1)*0.015,sz(2)*0.2,color=color(135,135,135),background=color(135,135,135),thickness=0.25);
    else
      xrect(orig(1)+sz(1)*(1-0.48-0.015),orig(2)+sz(2)*0.6,sz(1)*0.015,sz(2)*0.2,color=color(135,135,135),background=color(135,135,135),thickness=0.25);
    end
    if orient then
      xrect(orig(1)+sz(1)*0.535,orig(2)+sz(2)*0.6,sz(1)*0.015,sz(2)*0.2,color=color(135,135,135),background=color(135,135,135),thickness=0.25);
    else
      xrect(orig(1)+sz(1)*(1-0.535-0.015),orig(2)+sz(2)*0.6,sz(1)*0.015,sz(2)*0.2,color=color(135,135,135),background=color(135,135,135),thickness=0.25);
    end
    if orient then
      xrect(orig(1)+sz(1)*0.43,orig(2)+sz(2)*0.6,sz(1)*0.015,sz(2)*0.2,color=color(135,135,135),background=color(135,135,135),thickness=0.25);
    else
      xrect(orig(1)+sz(1)*(1-0.43-0.015),orig(2)+sz(2)*0.6,sz(1)*0.015,sz(2)*0.2,color=color(135,135,135),background=color(135,135,135),thickness=0.25);
    end
    if orient then
      xrect(orig(1)+sz(1)*0.595,orig(2)+sz(2)*0.6,sz(1)*0.125,sz(2)*0.2,color=color(135,135,135),background=color(135,135,135),thickness=0.25);
    else
      xrect(orig(1)+sz(1)*(1-0.595-0.125),orig(2)+sz(2)*0.6,sz(1)*0.125,sz(2)*0.2,color=color(135,135,135),background=color(135,135,135),thickness=0.25);
    end
    if orient then
      xstring(orig(1)+sz(1)*0.5,orig(2)+sz(2)*0.05,model.label,w=sz(1)*0.995,h=sz(2)*0.2,fill=%t,color=color(0,0,255));
    else
      xstring(orig(1)+sz(1)*(-0.495),orig(2)+sz(2)*0.05,model.label,w=sz(1)*0.995,h=sz(2)*0.2,fill=%t,color=color(0,0,255));
    end
  endfunction

x=[];y=[];typ=[];

select job
  case 'plot' then
    k=arg1.graphics.exprs(1);
    standard_draw(arg1,%f,_CEAB_TranslationalEMF_dp);
  case 'getinputs' then
    [x,y,typ]=_CEAB_TranslationalEMF_ip(arg1);
  case 'getoutputs' then
    [x,y,typ]=_CEAB_TranslationalEMF_op(arg1);
  case 'getorigin' then
    [x,y]=standard_origin(arg1);
  case 'set' then
    x=arg1;
    graphics=arg1.graphics;exprs=graphics.exprs;
    model=arg1.model;
    while %t do
      [ok,k,exprs]=..
        getvalue(['';'CEAB_TranslationalEMF';'';'Electromotoric force (electric/mechanic transformer)';''],..
        [' k [N/A] : Transformation coefficient'],..
        list('vec',1),exprs);
      if ~ok then break, end
      model.equations.parameters(2)=list(k)
      model.in=[1;1];
      model.out=[1;1];
      graphics.exprs=exprs;
      x.graphics=graphics;x.model=model;
      break
    end
  case 'define' then
    k=1;
    model=scicos_model();
    model.sim='Coselica';
    model.blocktype='c';
    model.dep_ut=[%t %f];
    model.in=[1;1];
    model.out=[1;1];
    mo=modelica();
      mo.model='Coselica.Electrical.Analog.Basic.TranslationalEMF';
      mo.inputs=['p','support'];
      mo.outputs=['n','flange'];
      mo.parameters=list(['k'],..
                         list(k),..
                         [0]);
    model.equations=mo;
    exprs=[strcat(sci2exp(k))];
    gr_i="blk_draw(sz,orig,orient,model.label)";
    x=standard_define([2 2],model,exprs,list(gr_i,0));
    x.graphics.in_implicit=['I','I'];
    x.graphics.out_implicit=['I','I'];
  end
endfunction
