// Coselica Toolbox for Scicos/Nsp
// Copyright (C) 2009-2016  Dirk Reusch, Kybernetik Dr. Reusch
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

function [x,y,typ]=CEAI_IdealTransformer(job,arg1,arg2)

  function blk_draw(sz,orig,orient,label)
    if orient then
      xx=orig(1);yy=orig(2);
      ww=sz(1);hh=sz(2);
    else
      xx=orig(1)+sz(1);yy=orig(2);
      ww=-sz(1);hh=sz(2);
    end
    if orient then
      xstring(orig(1)+sz(1)*0,orig(2)+sz(2)*0.9,model.label,w=sz(1)*1,h=sz(2)*0.174,fill=%t,color=color(0,0,255));
    else
      xstring(orig(1)+sz(1)*(0),orig(2)+sz(2)*0.9,model.label,w=sz(1)*1,h=sz(2)*0.174,fill=%t,color=color(0,0,255));
    end
    if orient then
      xarc(orig(1)+sz(1)*0.275,orig(2)+sz(2)*0.375,sz(1)*0.125,sz(2)*0.125,-5760,11520,color=color(0,0,255),thickness=0.25);
    else
      xarc(orig(1)+sz(1)*(1-0.275-0.125),orig(2)+sz(2)*0.375,sz(1)*0.125,sz(2)*0.125,5760,11520,color=color(0,0,255),thickness=0.25);
    end
    if orient then
      xarc(orig(1)+sz(1)*0.275,orig(2)+sz(2)*0.5,sz(1)*0.125,sz(2)*0.125,-5760,11520,color=color(0,0,255),thickness=0.25);
    else
      xarc(orig(1)+sz(1)*(1-0.275-0.125),orig(2)+sz(2)*0.5,sz(1)*0.125,sz(2)*0.125,5760,11520,color=color(0,0,255),thickness=0.25);
    end
    if orient then
      xarc(orig(1)+sz(1)*0.275,orig(2)+sz(2)*0.625,sz(1)*0.125,sz(2)*0.125,-5760,11520,color=color(0,0,255),thickness=0.25);
    else
      xarc(orig(1)+sz(1)*(1-0.275-0.125),orig(2)+sz(2)*0.625,sz(1)*0.125,sz(2)*0.125,5760,11520,color=color(0,0,255),thickness=0.25);
    end
    if orient then
      xarc(orig(1)+sz(1)*0.275,orig(2)+sz(2)*0.75,sz(1)*0.125,sz(2)*0.125,-5760,11520,color=color(0,0,255),thickness=0.25);
    else
      xarc(orig(1)+sz(1)*(1-0.275-0.125),orig(2)+sz(2)*0.75,sz(1)*0.125,sz(2)*0.125,5760,11520,color=color(0,0,255),thickness=0.25);
    end
    xpoly(xx+ww*[0.05;0.34],yy+hh*[0.75;0.75],color=color(0,0,255),thickness=0.25);
    xpoly(xx+ww*[0.05;0.34],yy+hh*[0.25;0.25],color=color(0,0,255),thickness=0.25);
    if orient then
      xarc(orig(1)+sz(1)*0.6,orig(2)+sz(2)*0.375,sz(1)*0.125,sz(2)*0.125,5760,11520,color=color(0,0,255),thickness=0.25);
    else
      xarc(orig(1)+sz(1)*(1-0.6-0.125),orig(2)+sz(2)*0.375,sz(1)*0.125,sz(2)*0.125,-5760,11520,color=color(0,0,255),thickness=0.25);
    end
    if orient then
      xarc(orig(1)+sz(1)*0.6,orig(2)+sz(2)*0.5,sz(1)*0.125,sz(2)*0.125,5760,11520,color=color(0,0,255),thickness=0.25);
    else
      xarc(orig(1)+sz(1)*(1-0.6-0.125),orig(2)+sz(2)*0.5,sz(1)*0.125,sz(2)*0.125,-5760,11520,color=color(0,0,255),thickness=0.25);
    end
    if orient then
      xarc(orig(1)+sz(1)*0.6,orig(2)+sz(2)*0.625,sz(1)*0.125,sz(2)*0.125,5760,11520,color=color(0,0,255),thickness=0.25);
    else
      xarc(orig(1)+sz(1)*(1-0.6-0.125),orig(2)+sz(2)*0.625,sz(1)*0.125,sz(2)*0.125,-5760,11520,color=color(0,0,255),thickness=0.25);
    end
    if orient then
      xarc(orig(1)+sz(1)*0.6,orig(2)+sz(2)*0.75,sz(1)*0.125,sz(2)*0.125,5760,11520,color=color(0,0,255),thickness=0.25);
    else
      xarc(orig(1)+sz(1)*(1-0.6-0.125),orig(2)+sz(2)*0.75,sz(1)*0.125,sz(2)*0.125,-5760,11520,color=color(0,0,255),thickness=0.25);
    end
    xpoly(xx+ww*[0.66;0.95],yy+hh*[0.75;0.75],color=color(0,0,255),thickness=0.25);
    xpoly(xx+ww*[0.66;0.95],yy+hh*[0.25;0.25],color=color(0,0,255),thickness=0.25);
    if orient then
      xstring(orig(1)+sz(1)*0,orig(2)+sz(2)*0,"n="+string(n)+"",w=sz(1)*1,h=sz(2)*0.2,fill=%t,color=color(0,0,0));
    else
      xstring(orig(1)+sz(1)*(0),orig(2)+sz(2)*0,"n="+string(n)+"",w=sz(1)*1,h=sz(2)*0.2,fill=%t,color=color(0,0,0));
    end
  endfunction

x=[];y=[];typ=[];

select job
  case 'plot' then
    n=arg1.graphics.exprs(1);
    standard_draw(arg1,%f,_MEAI_TwoPort_dp);
  case 'getinputs' then
    [x,y,typ]=_MEAI_TwoPort_ip(arg1);
  case 'getoutputs' then
    [x,y,typ]=_MEAI_TwoPort_op(arg1);
  case 'getorigin' then
    [x,y]=standard_origin(arg1);
  case 'set' then
    x=arg1;
    graphics=arg1.graphics;exprs=graphics.exprs;
    model=arg1.model;
    while %t do
      [ok,n,exprs]=..
        getvalue(['';'CEAI_IdealTransformer';'';'Ideal electrical transformer';''],..
        [' n [-] : Turns ratio'],..
        list('vec',1),exprs);
      if ~ok then break, end
      model.equations.parameters(2)=list(n)
      model.in=[1;1];
      model.out=[1;1];
      graphics.exprs=exprs;
      x.graphics=graphics;x.model=model;
      break
    end
  case 'define' then
    n=1;
    model=scicos_model();
    model.sim='Coselica';
    model.blocktype='c';
    model.dep_ut=[%t %f];
    model.in=[1;1];
    model.out=[1;1];
    mo=modelica();
      mo.model='Coselica.Electrical.Analog.Ideal.IdealTransformer';
      mo.inputs=['p1','n1'];
      mo.outputs=['p2','n2'];
      mo.parameters=list(['n'],..
                         list(n),..
                         [0]);
    model.equations=mo;
    exprs=[strcat(sci2exp(n))];
    gr_i="blk_draw(sz,orig,orient,model.label)";
    x=standard_define([2 2],model,exprs,list(gr_i,0));
    x.graphics.in_implicit=['I','I'];
    x.graphics.out_implicit=['I','I'];
  end
endfunction
