// Coselica Toolbox for Scicos/Nsp
// Copyright (C) 2009-2016  Dirk Reusch, Kybernetik Dr. Reusch
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

function [x,y,typ]=CEMB_PlugToPin_p(job,arg1,arg2)

  function blk_draw(sz,orig,orient,label)
    if orient then
      xx=orig(1);yy=orig(2);
      ww=sz(1);hh=sz(2);
    else
      xx=orig(1)+sz(1);yy=orig(2);
      ww=-sz(1);hh=sz(2);
    end
    if orient then
      xstring(orig(1)+sz(1)*-0.25,orig(2)+sz(2)*0.7,model.label,w=sz(1)*1.5,h=sz(2)*0.3,fill=%t,color=color(0,0,255));
    else
      xstring(orig(1)+sz(1)*(-0.25),orig(2)+sz(2)*0.7,model.label,w=sz(1)*1.5,h=sz(2)*0.3,fill=%t,color=color(0,0,255));
    end
    if orient then
      xstring(orig(1)+sz(1)*0,orig(2)+sz(2)*0.1,"k = "+string(k)+"",w=sz(1)*1,h=sz(2)*0.2,fill=%t,color=color(0,0,0));
    else
      xstring(orig(1)+sz(1)*(0),orig(2)+sz(2)*0.1,"k = "+string(k)+"",w=sz(1)*1,h=sz(2)*0.2,fill=%t,color=color(0,0,0));
    end
    if orient then
      xarc(orig(1)+sz(1)*0.3,orig(2)+sz(2)*0.6,sz(1)*0.2,sz(2)*0.2,0,23040,color=color(0,0,0),thickness=0.25);
    else
      xarc(orig(1)+sz(1)*(1-0.3-0.2),orig(2)+sz(2)*0.6,sz(1)*0.2,sz(2)*0.2,-11520,23040,color=color(0,0,0),thickness=0.25);
    end
    xpoly(xx+ww*[0.4;0.7;0.7;0.4],yy+hh*[0.6;0.6;0.4;0.4],color=color(0,0,0),thickness=0.25);
  endfunction

x=[];y=[];typ=[];

select job
  case 'plot' then
    m=arg1.graphics.exprs(1);
    k=arg1.graphics.exprs(2);
    m=strcat(sci2exp(double(evstr(m))));
    k=strcat(sci2exp(double(evstr(k))));
    standard_draw(arg1,%f,_CEMB_PlugToPin_p_dp);
  case 'getinputs' then
    [x,y,typ]=_CEMB_PlugToPin_p_ip(arg1);
  case 'getoutputs' then
    [x,y,typ]=_CEMB_PlugToPin_p_op(arg1);
  case 'getorigin' then
    [x,y]=standard_origin(arg1);
  case 'set' then
    x=arg1;
    graphics=arg1.graphics;exprs=graphics.exprs;
    model=arg1.model;
    while %t do
      [ok,m,k,exprs]=..
        getvalue(['';'CEMB_PlugToPin_p';'';'Connect one (positive) Pin';''],..
        [' m [-] : number of phases (>1)',' k [-] : phase index (1<=k<=m)'],..
        list('vec',1,'vec',1),exprs);
      if ~ok then break, end
      model.equations.parameters(2)=list(m,k)
      m=double(m);
      k=double(k);
      model.in=[1];
      model.out=[1];
      graphics.exprs=exprs;
      x.graphics=graphics;x.model=model;
      break
    end
  case 'define' then
    m=3;
    k=1;
    model=scicos_model();
    model.sim='Coselica';
    model.blocktype='c';
    model.dep_ut=[%t %f];
    model.in=[1];
    model.out=[1];
    m=int32(3);
    k=int32(1);
    mo=modelica();
      mo.model='Coselica.Electrical.MultiPhase.Basic.PlugToPin_p';
      mo.inputs=['plug_p'];
      mo.outputs=['pin_p'];
      mo.parameters=list(['m','k'],..
                         list(m,k),..
                         [0,0]);
    model.equations=mo;
    exprs=[strcat(sci2exp(m));strcat(sci2exp(k))];
    gr_i="blk_draw(sz,orig,orient,model.label)";
    x=standard_define([2 2],model,exprs,list(gr_i,0));
    x.graphics.in_implicit=['I'];
    x.graphics.out_implicit=['I'];
  end
endfunction
