// Coselica Toolbox for Scicos/Nsp
// Copyright (C) 2009-2016  Dirk Reusch, Kybernetik Dr. Reusch
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

function [x,y,typ]=CMPF_FrameForce(job,arg1,arg2)

  function blk_draw(sz,orig,orient,label)
    if orient then
      xx=orig(1);yy=orig(2);
      ww=sz(1);hh=sz(2);
    else
      xx=orig(1)+sz(1);yy=orig(2);
      ww=-sz(1);hh=sz(2);
    end
    if orient then
      xstring(orig(1)+sz(1)*0.055,orig(2)+sz(2)*0.12,"resolve",w=sz(1)*0.9,h=sz(2)*0.15,fill=%t,color=color(0,0,255));
    else
      xstring(orig(1)+sz(1)*(0.045),orig(2)+sz(2)*0.12,"resolve",w=sz(1)*0.9,h=sz(2)*0.15,fill=%t,color=color(0,0,255));
    end
    xfpoly(xx+ww*[0;0.75;0.75;0.985;0.75;0.75;0;0],yy+hh*[0.55;0.55;0.655;0.5;0.345;0.45;0.45;0.55],color=color(0,0,0),fill_color=color(0,0,0),thickness=0.25);
    if orient then
      xstring(orig(1)+sz(1)*-0.245,orig(2)+sz(2)*0.71,model.label,w=sz(1)*1.425,h=sz(2)*0.305,fill=%t,color=color(0,0,255));
    else
      xstring(orig(1)+sz(1)*(-0.18),orig(2)+sz(2)*0.71,model.label,w=sz(1)*1.425,h=sz(2)*0.305,fill=%t,color=color(0,0,255));
    end
    xpoly(xx+ww*[0.5;0.5],yy+hh*[0.445;0],color=color(255,255,0),thickness=0.25);
  endfunction

x=[];y=[];typ=[];

select job
  case 'plot' then
    standard_draw(arg1,%f,_CMPF_FrameForce_dp);
  case 'getinputs' then
    [x,y,typ]=_CMPF_FrameForce_ip(arg1);
  case 'getoutputs' then
    [x,y,typ]=_CMPF_FrameForce_op(arg1);
  case 'getorigin' then
    [x,y]=standard_origin(arg1);
  case 'set' then
    x=arg1;
  case 'define' then
    model=scicos_model();
    model.sim='Coselica';
    model.blocktype='c';
    model.dep_ut=[%t %f];
    model.in=[2];
    model.out=[1;1];
    mo=modelica();
      mo.model='Coselica.Mechanics.Planar.Forces.FrameForce';
      mo.inputs=['force'];
      mo.outputs=['frame_b','frame_resolve'];
      mo.parameters=list([],list(),[]);
    model.equations=mo;
    exprs=[];
    gr_i="blk_draw(sz,orig,orient,model.label)";
    x=standard_define([2 2],model,exprs,list(gr_i,0));
    x.graphics.in_implicit=['E'];
    x.graphics.out_implicit=['I','I'];
  end
endfunction
