// Coselica Toolbox for Scicos/Nsp
// Copyright (C) 2009-2016  Dirk Reusch, Kybernetik Dr. Reusch
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

function [x,y,typ]=CMPF_LineForce(job,arg1,arg2)

  function blk_draw(sz,orig,orient,label)
    if orient then
      xx=orig(1);yy=orig(2);
      ww=sz(1);hh=sz(2);
    else
      xx=orig(1)+sz(1);yy=orig(2);
      ww=-sz(1);hh=sz(2);
    end
    if orient then
      xarc(orig(1)+sz(1)*0.025,orig(2)+sz(2)*0.7,sz(1)*0.4,sz(2)*0.4,0,23040,color=color(0,0,0),background=color(192,192,192),thickness=0.25);
    else
      xarc(orig(1)+sz(1)*(1-0.025-0.4),orig(2)+sz(2)*0.7,sz(1)*0.4,sz(2)*0.4,-11520,23040,color=color(0,0,0),background=color(192,192,192),thickness=0.25);
    end
    if orient then
      xarc(orig(1)+sz(1)*0.075,orig(2)+sz(2)*0.65,sz(1)*0.3,sz(2)*0.3,0,23040,color=color(0,0,0),background=color(255,255,255),thickness=0.25);
    else
      xarc(orig(1)+sz(1)*(1-0.075-0.3),orig(2)+sz(2)*0.65,sz(1)*0.3,sz(2)*0.3,-11520,23040,color=color(0,0,0),background=color(255,255,255),thickness=0.25);
    end
    if orient then
      xarc(orig(1)+sz(1)*0.575,orig(2)+sz(2)*0.7,sz(1)*0.4,sz(2)*0.4,0,23040,color=color(0,0,0),background=color(192,192,192),thickness=0.25);
    else
      xarc(orig(1)+sz(1)*(1-0.575-0.4),orig(2)+sz(2)*0.7,sz(1)*0.4,sz(2)*0.4,-11520,23040,color=color(0,0,0),background=color(192,192,192),thickness=0.25);
    end
    if orient then
      xarc(orig(1)+sz(1)*0.615,orig(2)+sz(2)*0.645,sz(1)*0.3,sz(2)*0.295,0,23040,color=color(128,128,128),background=color(255,255,255),thickness=0.25);
    else
      xarc(orig(1)+sz(1)*(1-0.615-0.3),orig(2)+sz(2)*0.645,sz(1)*0.3,sz(2)*0.295,-11520,23040,color=color(128,128,128),background=color(255,255,255),thickness=0.25);
    end
    if orient then
      xstring(orig(1)+sz(1)*-0.225,orig(2)+sz(2)*-0.065,model.label,w=sz(1)*1.45,h=sz(2)*0.3,fill=%t,color=color(0,0,255));
    else
      xstring(orig(1)+sz(1)*(-0.225),orig(2)+sz(2)*-0.065,model.label,w=sz(1)*1.45,h=sz(2)*0.3,fill=%t,color=color(0,0,255));
    end
    if orient then
      xrect(orig(1)+sz(1)*0.3,orig(2)+sz(2)*0.705,sz(1)*0.42,sz(2)*0.405,color=color(255,255,255),background=color(255,255,255),thickness=0.25);
    else
      xrect(orig(1)+sz(1)*(1-0.3-0.42),orig(2)+sz(2)*0.705,sz(1)*0.42,sz(2)*0.405,color=color(255,255,255),background=color(255,255,255),thickness=0.25);
    end
    if orient then
      xarc(orig(1)+sz(1)*0.15,orig(2)+sz(2)*0.575,sz(1)*0.145,sz(2)*0.14,0,23040,color=color(0,0,0),background=color(192,192,192),thickness=0.25);
    else
      xarc(orig(1)+sz(1)*(1-0.15-0.145),orig(2)+sz(2)*0.575,sz(1)*0.145,sz(2)*0.14,-11520,23040,color=color(0,0,0),background=color(192,192,192),thickness=0.25);
    end
    if orient then
      xarc(orig(1)+sz(1)*0.7,orig(2)+sz(2)*0.57,sz(1)*0.145,sz(2)*0.14,0,23040,color=color(0,0,0),background=color(192,192,192),thickness=0.25);
    else
      xarc(orig(1)+sz(1)*(1-0.7-0.145),orig(2)+sz(2)*0.57,sz(1)*0.145,sz(2)*0.14,-11520,23040,color=color(0,0,0),background=color(192,192,192),thickness=0.25);
    end
    xpoly(xx+ww*[0.22;0.22;0.35;0.35;0.2;0.2],yy+hh*[0.5;0.615;0.615;0.85;0.85;1],color=color(0,0,0),thickness=0.25);
    xpoly(xx+ww*[0.775;0.775;0.65;0.65;0.8;0.8],yy+hh*[0.495;0.6;0.6;0.85;0.85;1],color=color(0,0,0),thickness=0.25);
    xpoly(xx+ww*[0.22;0.775],yy+hh*[0.5;0.495],color=color(0,0,0),thickness=0.25);
  endfunction

x=[];y=[];typ=[];

select job
  case 'plot' then
    s_small=arg1.graphics.exprs(1);
    standard_draw(arg1,%f,_CMPF_LineForce_dp);
  case 'getinputs' then
    [x,y,typ]=_CMPF_LineForce_ip(arg1);
  case 'getoutputs' then
    [x,y,typ]=_CMPF_LineForce_op(arg1);
  case 'getorigin' then
    [x,y]=standard_origin(arg1);
  case 'set' then
    x=arg1;
    graphics=arg1.graphics;exprs=graphics.exprs;
    model=arg1.model;
    while %t do
      [ok,s_small,exprs]=..
        getvalue(['';'CMPF_LineForce';'';'General line force component';''],..
        [' s_small [m] : Prevent zero-division if distance between frame_a and frame_b is zero'],..
        list('vec',1),exprs);
      if ~ok then break, end
      model.equations.parameters(2)=list(s_small)
      model.in=[1;1];
      model.out=[1;1];
      graphics.exprs=exprs;
      x.graphics=graphics;x.model=model;
      break
    end
  case 'define' then
    s_small=1.000D-10;
    model=scicos_model();
    model.sim='Coselica';
    model.blocktype='c';
    model.dep_ut=[%t %f];
    model.in=[1;1];
    model.out=[1;1];
    mo=modelica();
      mo.model='Coselica.Mechanics.Planar.Forces.LineForce';
      mo.inputs=['frame_a','flange_a'];
      mo.outputs=['frame_b','flange_b'];
      mo.parameters=list(['s_small'],..
                         list(s_small),..
                         [0]);
    model.equations=mo;
    exprs=[strcat(sci2exp(s_small))];
    gr_i="blk_draw(sz,orig,orient,model.label)";
    x=standard_define([2 2],model,exprs,list(gr_i,0));
    x.graphics.in_implicit=['I','I'];
    x.graphics.out_implicit=['I','I'];
  end
endfunction
