// Coselica Toolbox for Scicos/Nsp
// Copyright (C) 2009-2016  Dirk Reusch, Kybernetik Dr. Reusch
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

function [x,y,typ]=CMPF_WorldTorque(job,arg1,arg2)

  function blk_draw(sz,orig,orient,label)
    if orient then
      xx=orig(1);yy=orig(2);
      ww=sz(1);hh=sz(2);
    else
      xx=orig(1)+sz(1);yy=orig(2);
      ww=-sz(1);hh=sz(2);
    end
    if orient then
      xstring(orig(1)+sz(1)*-0.12,orig(2)+sz(2)*0.065,model.label,w=sz(1)*1.3,h=sz(2)*0.3,fill=%t,color=color(0,0,255));
    else
      xstring(orig(1)+sz(1)*(-0.18),orig(2)+sz(2)*0.065,model.label,w=sz(1)*1.3,h=sz(2)*0.3,fill=%t,color=color(0,0,255));
    end
    if orient then
      xstring(orig(1)+sz(1)*-0.015,orig(2)+sz(2)*0.935,"world",w=sz(1)*0.815,h=sz(2)*0.2,fill=%t,color=color(0,0,255));
    else
      xstring(orig(1)+sz(1)*(0.2),orig(2)+sz(2)*0.935,"world",w=sz(1)*0.815,h=sz(2)*0.2,fill=%t,color=color(0,0,255));
    end
    xpoly(xx+ww*[0;0.03;0.07;0.13;0.175;0.24;0.325;0.39;0.46;0.535;0.595;0.66;0.72;0.76;0.79],yy+hh*[0.5;0.565;0.64;0.74;0.8;0.86;0.905;0.92;0.92;0.9;0.865;0.825;0.775;0.735;0.7],color=color(0,0,0),thickness=0.5);
    xfpoly(xx+ww*[0.985;0.875;0.705;0.985],yy+hh*[0.5;0.795;0.62;0.5],color=color(0,0,0),fill_color=color(0,0,0),thickness=0.25);
  endfunction

x=[];y=[];typ=[];

select job
  case 'plot' then
    standard_draw(arg1,%f,_CMPF_WorldForce_dp);
  case 'getinputs' then
    [x,y,typ]=_CMPF_WorldForce_ip(arg1);
  case 'getoutputs' then
    [x,y,typ]=_CMPF_WorldForce_op(arg1);
  case 'getorigin' then
    [x,y]=standard_origin(arg1);
  case 'set' then
    x=arg1;
  case 'define' then
    model=scicos_model();
    model.sim='Coselica';
    model.blocktype='c';
    model.dep_ut=[%t %f];
    model.in=[1];
    model.out=[1];
    mo=modelica();
      mo.model='Coselica.Mechanics.Planar.Forces.WorldTorque';
      mo.inputs=['torque'];
      mo.outputs=['frame_b'];
      mo.parameters=list([],list(),[]);
    model.equations=mo;
    exprs=[];
    gr_i="blk_draw(sz,orig,orient,model.label)";
    x=standard_define([2 2],model,exprs,list(gr_i,0));
    x.graphics.in_implicit=['E'];
    x.graphics.out_implicit=['I'];
  end
endfunction
