// Coselica Toolbox for Scicos/Nsp
// Copyright (C) 2009-2016  Dirk Reusch, Kybernetik Dr. Reusch
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

function [x,y,typ]=CMPJ_ActuatedRevolute(job,arg1,arg2)

  function blk_draw(sz,orig,orient,label)
    if orient then
      xx=orig(1);yy=orig(2);
      ww=sz(1);hh=sz(2);
    else
      xx=orig(1)+sz(1);yy=orig(2);
      ww=-sz(1);hh=sz(2);
    end
    if orient then
      xstring(orig(1)+sz(1)*-0.185,orig(2)+sz(2)*-0.125,model.label,w=sz(1)*1.38,h=sz(2)*0.285,fill=%t,color=color(0,0,0));
    else
      xstring(orig(1)+sz(1)*(-0.195),orig(2)+sz(2)*-0.125,model.label,w=sz(1)*1.38,h=sz(2)*0.285,fill=%t,color=color(0,0,0));
    end
    if orient then
      xrect(orig(1)+sz(1)*0.4,orig(2)+sz(2)*0.55,sz(1)*0.2,sz(2)*0.1,color=color(0,0,0),background=color(192,192,192),thickness=0.25);
    else
      xrect(orig(1)+sz(1)*(1-0.4-0.2),orig(2)+sz(2)*0.55,sz(1)*0.2,sz(2)*0.1,color=color(0,0,0),background=color(192,192,192),thickness=0.25);
    end
    if orient then
      xrect(orig(1)+sz(1)*0,orig(2)+sz(2)*0.8,sz(1)*0.35,sz(2)*0.6,color=color(0,0,0),background=color(192,192,192),thickness=0.25);
    else
      xrect(orig(1)+sz(1)*(1-0-0.35),orig(2)+sz(2)*0.8,sz(1)*0.35,sz(2)*0.6,color=color(0,0,0),background=color(192,192,192),thickness=0.25);
    end
    if orient then
      xrect(orig(1)+sz(1)*0.65,orig(2)+sz(2)*0.8,sz(1)*0.35,sz(2)*0.6,color=color(0,0,0),background=color(192,192,192),thickness=0.25);
    else
      xrect(orig(1)+sz(1)*(1-0.65-0.35),orig(2)+sz(2)*0.8,sz(1)*0.35,sz(2)*0.6,color=color(0,0,0),background=color(192,192,192),thickness=0.25);
    end
    if orient then
      xstring(orig(1)+sz(1)*0.05,orig(2)+sz(2)*0.445,"a",w=sz(1)*0.18,h=sz(2)*0.125,fill=%t,color=color(128,128,128));
    else
      xstring(orig(1)+sz(1)*(0.77),orig(2)+sz(2)*0.445,"a",w=sz(1)*0.18,h=sz(2)*0.125,fill=%t,color=color(128,128,128));
    end
    if orient then
      xstring(orig(1)+sz(1)*0.755,orig(2)+sz(2)*0.43,"b",w=sz(1)*0.18,h=sz(2)*0.125,fill=%t,color=color(128,128,128));
    else
      xstring(orig(1)+sz(1)*(0.065),orig(2)+sz(2)*0.43,"b",w=sz(1)*0.18,h=sz(2)*0.125,fill=%t,color=color(128,128,128));
    end
    xpoly(xx+ww*[0.4;0.2],yy+hh*[0.85;0.85],color=color(0,0,0),thickness=0.25);
    xpoly(xx+ww*[0.4;0.4],yy+hh*[0.9;0.8],color=color(0,0,0),thickness=0.25);
    xpoly(xx+ww*[0.6;0.6],yy+hh*[0.9;0.8],color=color(0,0,0),thickness=0.25);
    xpoly(xx+ww*[0.6;0.705],yy+hh*[0.85;0.85],color=color(0,0,0),thickness=0.25);
    if orient then
      xrect(orig(1)+sz(1)*0.45,orig(2)+sz(2)*1,sz(1)*0.1,sz(2)*0.25,color=color(0,0,0),background=color(192,192,192),thickness=0.25);
    else
      xrect(orig(1)+sz(1)*(1-0.45-0.1),orig(2)+sz(2)*1,sz(1)*0.1,sz(2)*0.25,color=color(0,0,0),background=color(192,192,192),thickness=0.25);
    end
    xfpoly(xx+ww*[0.45;0.55;0.65;0.35;0.45],yy+hh*[0.65;0.65;0.75;0.75;0.65],color=color(0,0,0),fill_color=color(192,192,192),thickness=0.25);
    xpoly(xx+ww*[0.2;0.2],yy+hh*[0.8;0.95],color=color(0,0,0),thickness=0.25);
    if orient then
      xrect(orig(1)+sz(1)*0.35,orig(2)+sz(2)*0.555,sz(1)*0.2,sz(2)*0.105,color=color(0,0,0),background=color(192,192,192),thickness=0.25);
    else
      xrect(orig(1)+sz(1)*(1-0.35-0.2),orig(2)+sz(2)*0.555,sz(1)*0.2,sz(2)*0.105,color=color(0,0,0),background=color(192,192,192),thickness=0.25);
    end
    xfpoly(xx+ww*[0.55;0.65;0.65;0.55;0.55],yy+hh*[0.65;0.75;0.25;0.35;0.65],color=color(0,0,0),fill_color=color(192,192,192),thickness=0.25);
  endfunction

x=[];y=[];typ=[];

select job
  case 'plot' then
    phi_offset=arg1.graphics.exprs(1);
    initType=arg1.graphics.exprs(2);
    phi_start=arg1.graphics.exprs(3);
    w_start=arg1.graphics.exprs(4);
    z_start=arg1.graphics.exprs(5);
    standard_draw(arg1,%f,_CMPJ_ActuatedRevolute_dp);
  case 'getinputs' then
    [x,y,typ]=_CMPJ_ActuatedRevolute_ip(arg1);
  case 'getoutputs' then
    [x,y,typ]=_CMPJ_ActuatedRevolute_op(arg1);
  case 'getorigin' then
    [x,y]=standard_origin(arg1);
  case 'set' then
    x=arg1;
    graphics=arg1.graphics;exprs=graphics.exprs;
    model=arg1.model;
    while %t do
      [ok,phi_offset,initType,phi_start,w_start,z_start,exprs]=..
        getvalue(['';'CMPJ_ActuatedRevolute';'';'Actuated revolute joint (1 rotational degree-of-freedom, 2 states)';''],..
        [' phi_offset [rad] : Relative angle offset (angle = phi + phi_offset)',' initType [-] : Type of initial value for [phi,w,z] (0=guess,1=fixed)',' phi_start [rad] : Initial value of rotation angle phi',' w_start [rad/s] : Initial value of relative angular velocity w = der(phi)',' z_start [rad/s2] : Initial value of relative angular acceleration z = der(w)'],..
        list('vec',1,'vec',3,'vec',1,'vec',1,'vec',1),exprs);
      if ~ok then break, end
      model.equations.parameters(2)=list(phi_offset,initType,phi_start,w_start,z_start)
      model.in=[1;1];
      model.out=[1;1];
      graphics.exprs=exprs;
      x.graphics=graphics;x.model=model;
      break
    end
  case 'define' then
    phi_offset=0;
    initType=[0,0,0];
    phi_start=0;
    w_start=0;
    z_start=0;
    model=scicos_model();
    model.sim='Coselica';
    model.blocktype='c';
    model.dep_ut=[%t %f];
    model.in=[1;1];
    model.out=[1;1];
    mo=modelica();
      mo.model='Coselica.Mechanics.Planar.Joints.ActuatedRevolute';
      mo.inputs=['frame_a','bearing'];
      mo.outputs=['frame_b','axis'];
      mo.parameters=list(['phi_offset','initType','phi_start','w_start','z_start'],..
                         list(phi_offset,initType,phi_start,w_start,z_start),..
                         [0,0,0,0,0]);
    model.equations=mo;
    exprs=[strcat(sci2exp(phi_offset));strcat(sci2exp(initType));strcat(sci2exp(phi_start));strcat(sci2exp(w_start));strcat(sci2exp(z_start))];
    gr_i="blk_draw(sz,orig,orient,model.label)";
    x=standard_define([2 2],model,exprs,list(gr_i,0));
    x.graphics.in_implicit=['I','I'];
    x.graphics.out_implicit=['I','I'];
  end
endfunction
