// Coselica Toolbox for Scicos/Nsp
// Copyright (C) 2009-2016  Dirk Reusch, Kybernetik Dr. Reusch
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

function [x,y,typ]=CMPP_FixedRotation(job,arg1,arg2)

  function blk_draw(sz,orig,orient,label)
    if orient then
      xx=orig(1);yy=orig(2);
      ww=sz(1);hh=sz(2);
    else
      xx=orig(1)+sz(1);yy=orig(2);
      ww=-sz(1);hh=sz(2);
    end
    if orient then
      xstring(orig(1)+sz(1)*-0.18,orig(2)+sz(2)*0.895,model.label,w=sz(1)*1.34,h=sz(2)*0.3,fill=%t,color=color(0,0,0));
    else
      xstring(orig(1)+sz(1)*(-0.16),orig(2)+sz(2)*0.895,model.label,w=sz(1)*1.34,h=sz(2)*0.3,fill=%t,color=color(0,0,0));
    end
    if orient then
      xrect(orig(1)+sz(1)*0,orig(2)+sz(2)*0.525,sz(1)*1,sz(2)*0.05,color=color(0,0,0),background=color(0,0,0),thickness=0.25);
    else
      xrect(orig(1)+sz(1)*(1-0-1),orig(2)+sz(2)*0.525,sz(1)*1,sz(2)*0.05,color=color(0,0,0),background=color(0,0,0),thickness=0.25);
    end
    xpoly(xx+ww*[0.9;1.145],yy+hh*[0.6;0.75],color=color(0,0,0),thickness=0.25);
    xpoly(xx+ww*[0.9;0.785],yy+hh*[0.6;0.795],color=color(0,0,0),thickness=0.25);
    xfpoly(xx+ww*[1.22;1.085;1.16;1.22],yy+hh*[0.8;0.795;0.685;0.8],color=color(0,0,0),fill_color=color(0,0,4),thickness=0.25);
    xfpoly(xx+ww*[0.715;0.73;0.84;0.715],yy+hh*[0.9;0.75;0.825;0.9],color=color(0,0,0),fill_color=color(0,0,4),thickness=0.25);
    if orient then
      xstring(orig(1)+sz(1)*-0.225,orig(2)+sz(2)*0.05,"r="+string(r)+"",w=sz(1)*1.45,h=sz(2)*0.2,fill=%t,color=color(0,0,0));
    else
      xstring(orig(1)+sz(1)*(-0.225),orig(2)+sz(2)*0.05,"r="+string(r)+"",w=sz(1)*1.45,h=sz(2)*0.2,fill=%t,color=color(0,0,0));
    end
    if orient then
      xstring(orig(1)+sz(1)*-0.085,orig(2)+sz(2)*0.63,"a",w=sz(1)*0.18,h=sz(2)*0.125,fill=%t,color=color(127,127,127));
    else
      xstring(orig(1)+sz(1)*(0.905),orig(2)+sz(2)*0.63,"a",w=sz(1)*0.18,h=sz(2)*0.125,fill=%t,color=color(127,127,127));
    end
    if orient then
      xstring(orig(1)+sz(1)*0.92,orig(2)+sz(2)*0.255,"b",w=sz(1)*0.18,h=sz(2)*0.125,fill=%t,color=color(127,127,127));
    else
      xstring(orig(1)+sz(1)*(-0.1),orig(2)+sz(2)*0.255,"b",w=sz(1)*0.18,h=sz(2)*0.125,fill=%t,color=color(127,127,127));
    end
  endfunction

x=[];y=[];typ=[];

select job
  case 'plot' then
    r=arg1.graphics.exprs(1);
    angle=arg1.graphics.exprs(2);
    standard_draw(arg1,%f,_CMPI_PartialTwoFrames_dp);
  case 'getinputs' then
    [x,y,typ]=_CMPI_PartialTwoFrames_ip(arg1);
  case 'getoutputs' then
    [x,y,typ]=_CMPI_PartialTwoFrames_op(arg1);
  case 'getorigin' then
    [x,y]=standard_origin(arg1);
  case 'set' then
    x=arg1;
    graphics=arg1.graphics;exprs=graphics.exprs;
    model=arg1.model;
    while %t do
      [ok,r,angle,exprs]=..
        getvalue(['';'CMPP_FixedRotation';'';'Fixed translation followed by a fixed rotation of frame_b with respect to frame_a';''],..
        [' r [m] : Vector from frame_a to frame_b resolved in frame_a',' angle [rad] : Angle to rotate frame_a into frame_b'],..
        list('vec',2,'vec',1),exprs);
      if ~ok then break, end
      model.equations.parameters(2)=list(r,angle)
      model.in=[1];
      model.out=[1];
      graphics.exprs=exprs;
      x.graphics=graphics;x.model=model;
      break
    end
  case 'define' then
    r=[0,0];
    angle=0;
    model=scicos_model();
    model.sim='Coselica';
    model.blocktype='c';
    model.dep_ut=[%t %f];
    model.in=[1];
    model.out=[1];
    mo=modelica();
      mo.model='Coselica.Mechanics.Planar.Parts.FixedRotation';
      mo.inputs=['frame_a'];
      mo.outputs=['frame_b'];
      mo.parameters=list(['r','angle'],..
                         list(r,angle),..
                         [0,0]);
    model.equations=mo;
    exprs=[strcat(sci2exp(r));strcat(sci2exp(angle))];
    gr_i="blk_draw(sz,orig,orient,model.label)";
    x=standard_define([2 2],model,exprs,list(gr_i,0));
    x.graphics.in_implicit=['I'];
    x.graphics.out_implicit=['I'];
  end
endfunction
