// Coselica Toolbox for Scicos/Nsp
// Copyright (C) 2009-2016  Dirk Reusch, Kybernetik Dr. Reusch
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

function [x,y,typ]=CMPP_FixedTranslation(job,arg1,arg2)

  function blk_draw(sz,orig,orient,label)
    if orient then
      xx=orig(1);yy=orig(2);
      ww=sz(1);hh=sz(2);
    else
      xx=orig(1)+sz(1);yy=orig(2);
      ww=-sz(1);hh=sz(2);
    end
    if orient then
      xrect(orig(1)+sz(1)*0,orig(2)+sz(2)*0.525,sz(1)*1,sz(2)*0.05,color=color(0,0,0),background=color(0,0,0),thickness=0.25);
    else
      xrect(orig(1)+sz(1)*(1-0-1),orig(2)+sz(2)*0.525,sz(1)*1,sz(2)*0.05,color=color(0,0,0),background=color(0,0,0),thickness=0.25);
    end
    if orient then
      xstring(orig(1)+sz(1)*-0.15,orig(2)+sz(2)*0.7,model.label,w=sz(1)*1.3,h=sz(2)*0.3,fill=%t,color=color(0,0,255));
    else
      xstring(orig(1)+sz(1)*(-0.15),orig(2)+sz(2)*0.7,model.label,w=sz(1)*1.3,h=sz(2)*0.3,fill=%t,color=color(0,0,255));
    end
    if orient then
      xstring(orig(1)+sz(1)*-0.15,orig(2)+sz(2)*0.15,"r="+string(r)+"",w=sz(1)*1.3,h=sz(2)*0.25,fill=%t,color=color(0,0,0));
    else
      xstring(orig(1)+sz(1)*(-0.15),orig(2)+sz(2)*0.15,"r="+string(r)+"",w=sz(1)*1.3,h=sz(2)*0.25,fill=%t,color=color(0,0,0));
    end
    if orient then
      xstring(orig(1)+sz(1)*0.05,orig(2)+sz(2)*0.575,"a",w=sz(1)*0.2,h=sz(2)*0.125,fill=%t,color=color(127,127,127));
    else
      xstring(orig(1)+sz(1)*(0.75),orig(2)+sz(2)*0.575,"a",w=sz(1)*0.2,h=sz(2)*0.125,fill=%t,color=color(127,127,127));
    end
    if orient then
      xstring(orig(1)+sz(1)*0.75,orig(2)+sz(2)*0.575,"b",w=sz(1)*0.2,h=sz(2)*0.125,fill=%t,color=color(127,127,127));
    else
      xstring(orig(1)+sz(1)*(0.05),orig(2)+sz(2)*0.575,"b",w=sz(1)*0.2,h=sz(2)*0.125,fill=%t,color=color(127,127,127));
    end
  endfunction

x=[];y=[];typ=[];

select job
  case 'plot' then
    r=arg1.graphics.exprs(1);
    standard_draw(arg1,%f,_CMPI_PartialTwoFrames_dp);
  case 'getinputs' then
    [x,y,typ]=_CMPI_PartialTwoFrames_ip(arg1);
  case 'getoutputs' then
    [x,y,typ]=_CMPI_PartialTwoFrames_op(arg1);
  case 'getorigin' then
    [x,y]=standard_origin(arg1);
  case 'set' then
    x=arg1;
    graphics=arg1.graphics;exprs=graphics.exprs;
    model=arg1.model;
    while %t do
      [ok,r,exprs]=..
        getvalue(['';'CMPP_FixedTranslation';'';'Fixed translation of frame_b with respect to frame_a';''],..
        [' r [m] : Vector from frame_a to frame_b resolved in frame_a'],..
        list('vec',2),exprs);
      if ~ok then break, end
      model.equations.parameters(2)=list(r)
      model.in=[1];
      model.out=[1];
      graphics.exprs=exprs;
      x.graphics=graphics;x.model=model;
      break
    end
  case 'define' then
    r=[0,0];
    model=scicos_model();
    model.sim='Coselica';
    model.blocktype='c';
    model.dep_ut=[%t %f];
    model.in=[1];
    model.out=[1];
    mo=modelica();
      mo.model='Coselica.Mechanics.Planar.Parts.FixedTranslation';
      mo.inputs=['frame_a'];
      mo.outputs=['frame_b'];
      mo.parameters=list(['r'],..
                         list(r),..
                         [0]);
    model.equations=mo;
    exprs=[strcat(sci2exp(r))];
    gr_i="blk_draw(sz,orig,orient,model.label)";
    x=standard_define([2 2],model,exprs,list(gr_i,0));
    x.graphics.in_implicit=['I'];
    x.graphics.out_implicit=['I'];
  end
endfunction
