// Coselica Toolbox for Scicos/Nsp
// Copyright (C) 2009-2016  Dirk Reusch, Kybernetik Dr. Reusch
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

function [x,y,typ]=CMPP_PointMass(job,arg1,arg2)

  function blk_draw(sz,orig,orient,label)
    if orient then
      xx=orig(1);yy=orig(2);
      ww=sz(1);hh=sz(2);
    else
      xx=orig(1)+sz(1);yy=orig(2);
      ww=-sz(1);hh=sz(2);
    end
    if orient then
      xstring(orig(1)+sz(1)*-0.145,orig(2)+sz(2)*-0.01,"m="+string(m)+"",w=sz(1)*1.305,h=sz(2)*0.23,fill=%t,color=color(0,0,0));
    else
      xstring(orig(1)+sz(1)*(-0.16),orig(2)+sz(2)*-0.01,"m="+string(m)+"",w=sz(1)*1.305,h=sz(2)*0.23,fill=%t,color=color(0,0,0));
    end
    if orient then
      xstring(orig(1)+sz(1)*-0.14,orig(2)+sz(2)*0.775,model.label,w=sz(1)*1.3,h=sz(2)*0.275,fill=%t,color=color(0,0,255));
    else
      xstring(orig(1)+sz(1)*(-0.16),orig(2)+sz(2)*0.775,model.label,w=sz(1)*1.3,h=sz(2)*0.275,fill=%t,color=color(0,0,255));
    end
    if orient then
      xarc(orig(1)+sz(1)*0.25,orig(2)+sz(2)*0.75,sz(1)*0.5,sz(2)*0.5,0,23040,color=color(0,0,0),background=color(0,127,255),thickness=0.25);
    else
      xarc(orig(1)+sz(1)*(1-0.25-0.5),orig(2)+sz(2)*0.75,sz(1)*0.5,sz(2)*0.5,-11520,23040,color=color(0,0,0),background=color(0,127,255),thickness=0.25);
    end
  endfunction

x=[];y=[];typ=[];

select job
  case 'plot' then
    m=arg1.graphics.exprs(1);
    standard_draw(arg1,%f,_CMPP_PointMass_dp);
  case 'getinputs' then
    [x,y,typ]=_CMPP_PointMass_ip(arg1);
  case 'getoutputs' then
    [x,y,typ]=_CMPP_PointMass_op(arg1);
  case 'getorigin' then
    [x,y]=standard_origin(arg1);
  case 'set' then
    x=arg1;
    graphics=arg1.graphics;exprs=graphics.exprs;
    model=arg1.model;
    while %t do
      [ok,m,exprs]=..
        getvalue(['';'CMPP_PointMass';'';'Rigid body where body rotation and inertia is neglected (no states)';''],..
        [' m [kg] : Mass of mass point (m > 0)'],..
        list('vec',1),exprs);
      if ~ok then break, end
      model.equations.parameters(2)=list(m)
      model.in=[1];
      model.out=[];
      graphics.exprs=exprs;
      x.graphics=graphics;x.model=model;
      break
    end
  case 'define' then
    m=1;
    model=scicos_model();
    model.sim='Coselica';
    model.blocktype='c';
    model.dep_ut=[%t %f];
    model.in=[1];
    model.out=[];
    mo=modelica();
      mo.model='Coselica.Mechanics.Planar.Parts.PointMass';
      mo.inputs=['frame_a'];
      mo.outputs=[];
      mo.parameters=list(['m'],..
                         list(m),..
                         [0]);
    model.equations=mo;
    exprs=[strcat(sci2exp(m))];
    gr_i="blk_draw(sz,orig,orient,model.label)";
    x=standard_define([2 2],model,exprs,list(gr_i,0));
    x.graphics.in_implicit=['I'];
    x.graphics.out_implicit=[];
  end
endfunction
