// Coselica Toolbox for Scicos/Nsp
// Copyright (C) 2009-2016  Dirk Reusch, Kybernetik Dr. Reusch
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

function [x,y,typ]=CMPSR_AngularAcceleration(job,arg1,arg2)

  function blk_draw(sz,orig,orient,label)
    if orient then
      xx=orig(1);yy=orig(2);
      ww=sz(1);hh=sz(2);
    else
      xx=orig(1)+sz(1);yy=orig(2);
      ww=-sz(1);hh=sz(2);
    end
    if orient then
      xarc(orig(1)+sz(1)*0.15,orig(2)+sz(2)*0.85,sz(1)*0.7,sz(2)*0.7,0,23040,color=color(0,0,0),background=color(255,255,255),thickness=0.25);
    else
      xarc(orig(1)+sz(1)*(1-0.15-0.7),orig(2)+sz(2)*0.85,sz(1)*0.7,sz(2)*0.7,-11520,23040,color=color(0,0,0),background=color(255,255,255),thickness=0.25);
    end
    xpoly(xx+ww*[0.5;0.5],yy+hh*[0.85;0.7],color=color(0,0,0),thickness=0.25);
    xpoly(xx+ww*[0.6145;0.701],yy+hh*[0.664;0.7865],color=color(0,0,0),thickness=0.25);
    xpoly(xx+ww*[0.3855;0.299],yy+hh*[0.664;0.7865],color=color(0,0,0),thickness=0.25);
    xpoly(xx+ww*[0.688;0.829],yy+hh*[0.5685;0.6195],color=color(0,0,0),thickness=0.25);
    xpoly(xx+ww*[0.312;0.171],yy+hh*[0.5685;0.6195],color=color(0,0,0),thickness=0.25);
    xpoly(xx+ww*[0.5;0.5451],yy+hh*[0.5;0.643],color=color(0,0,0),thickness=0.25);
    xfpoly(xx+ww*[0.4976;0.59;0.59;0.4976],yy+hh*[0.658;0.63;0.786;0.658],color=color(0,0,0),fill_color=color(0,0,0),thickness=0.25);
    if orient then
      xarc(orig(1)+sz(1)*0.475,orig(2)+sz(2)*0.525,sz(1)*0.05,sz(2)*0.05,0,23040,color=color(0,0,0),background=color(0,0,0),thickness=0.25);
    else
      xarc(orig(1)+sz(1)*(1-0.475-0.05),orig(2)+sz(2)*0.525,sz(1)*0.05,sz(2)*0.05,-11520,23040,color=color(0,0,0),background=color(0,0,0),thickness=0.25);
    end
    xpoly(xx+ww*[0.5;0.5],yy+hh*[0.15;0],color=color(0,0,127),thickness=0.25);
    xpoly(xx+ww*[0.15;0],yy+hh*[0.5;0.5],color=color(0,0,0),thickness=0.25);
    xpoly(xx+ww*[0.85;1],yy+hh*[0.5;0.5],color=color(0,0,0),thickness=0.25);
    if orient then
      xstring(orig(1)+sz(1)*0.6,orig(2)+sz(2)*0,"z_rel",w=sz(1)*0.7,h=sz(2)*0.15,fill=%t,color=color(0,0,0));
    else
      xstring(orig(1)+sz(1)*(-0.3),orig(2)+sz(2)*0,"z_rel",w=sz(1)*0.7,h=sz(2)*0.15,fill=%t,color=color(0,0,0));
    end
    if orient then
      xstring(orig(1)+sz(1)*-0.25,orig(2)+sz(2)*0.9,model.label,w=sz(1)*1.5,h=sz(2)*0.2,fill=%t,color=color(0,0,0));
    else
      xstring(orig(1)+sz(1)*(-0.25),orig(2)+sz(2)*0.9,model.label,w=sz(1)*1.5,h=sz(2)*0.2,fill=%t,color=color(0,0,0));
    end
  endfunction

x=[];y=[];typ=[];

select job
  case 'plot' then
    standard_draw(arg1,%f,_CMPS_Angle_dp);
  case 'getinputs' then
    [x,y,typ]=_CMPS_Angle_ip(arg1);
  case 'getoutputs' then
    [x,y,typ]=_CMPS_Angle_op(arg1);
  case 'getorigin' then
    [x,y]=standard_origin(arg1);
  case 'set' then
    x=arg1;
  case 'define' then
    model=scicos_model();
    model.sim='Coselica';
    model.blocktype='c';
    model.dep_ut=[%t %f];
    model.in=[1];
    model.out=[1;1];
    mo=modelica();
      mo.model='Coselica.Mechanics.Planar.Sensors.Relative.AngularAcceleration';
      mo.inputs=['frame_a'];
      mo.outputs=['frame_b','z_rel'];
      mo.parameters=list([],list(),[]);
    model.equations=mo;
    exprs=[];
    gr_i="blk_draw(sz,orig,orient,model.label)";
    x=standard_define([2 2],model,exprs,list(gr_i,0));
    x.graphics.in_implicit=['I'];
    x.graphics.out_implicit=['I','I'];
  end
endfunction
