// Coselica Toolbox for Scicos/Nsp
// Copyright (C) 2009-2016  Dirk Reusch, Kybernetik Dr. Reusch
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

function [x,y,typ]=CMPSR_Position2(job,arg1,arg2)

  function blk_draw(sz,orig,orient,label)
    if orient then
      xx=orig(1);yy=orig(2);
      ww=sz(1);hh=sz(2);
    else
      xx=orig(1)+sz(1);yy=orig(2);
      ww=-sz(1);hh=sz(2);
    end
    if orient then
      xrect(orig(1)+sz(1)*0.15,orig(2)+sz(2)*0.6,sz(1)*0.7,sz(2)*0.4,color=color(0,0,0),background=color(255,255,255),thickness=0.25);
    else
      xrect(orig(1)+sz(1)*(1-0.15-0.7),orig(2)+sz(2)*0.6,sz(1)*0.7,sz(2)*0.4,color=color(0,0,0),background=color(255,255,255),thickness=0.25);
    end
    xfpoly(xx+ww*[0.5;0.45;0.55;0.5],yy+hh*[0.3;0.42;0.42;0.3],color=color(0,0,0),fill_color=color(0,0,0),thickness=0.25);
    xpoly(xx+ww*[0.5;0.5],yy+hh*[0.5;0.42],color=color(0,0,0),thickness=0.25);
    xpoly(xx+ww*[0.15;0.5],yy+hh*[0.5;0.5],color=color(0,0,0),thickness=0.25);
    xpoly(xx+ww*[0.25;0.25],yy+hh*[0.3;0.2],color=color(0,0,0),thickness=0.25);
    xpoly(xx+ww*[0.35;0.35],yy+hh*[0.3;0.2],color=color(0,0,0),thickness=0.25);
    xpoly(xx+ww*[0.45;0.45],yy+hh*[0.3;0.2],color=color(0,0,0),thickness=0.25);
    xpoly(xx+ww*[0.55;0.55],yy+hh*[0.3;0.2],color=color(0,0,0),thickness=0.25);
    xpoly(xx+ww*[0.65;0.65],yy+hh*[0.3;0.2],color=color(0,0,0),thickness=0.25);
    xpoly(xx+ww*[0.75;0.75],yy+hh*[0.3;0.2],color=color(0,0,0),thickness=0.25);
    if orient then
      xstring(orig(1)+sz(1)*0.4,orig(2)+sz(2)*0,"r_rel",w=sz(1)*0.9,h=sz(2)*0.15,fill=%t,color=color(0,0,0));
    else
      xstring(orig(1)+sz(1)*(-0.3),orig(2)+sz(2)*0,"r_rel",w=sz(1)*0.9,h=sz(2)*0.15,fill=%t,color=color(0,0,0));
    end
    xpoly(xx+ww*[0.5;0.5],yy+hh*[0.2;0],color=color(0,0,127),thickness=0.25);
    xpoly(xx+ww*[0.495;0.2;0.2],yy+hh*[0.12;0.12;0],color=color(255,255,0),thickness=0.25);
    xpoly(xx+ww*[0.15;0],yy+hh*[0.5;0.5],color=color(0,0,0),thickness=0.25);
    xpoly(xx+ww*[0.85;1],yy+hh*[0.5;0.5],color=color(0,0,0),thickness=0.25);
    if orient then
      xstring(orig(1)+sz(1)*-0.285,orig(2)+sz(2)*0.04,"resolve",w=sz(1)*0.655,h=sz(2)*0.125,fill=%t,color=color(192,192,192));
    else
      xstring(orig(1)+sz(1)*(0.63),orig(2)+sz(2)*0.04,"resolve",w=sz(1)*0.655,h=sz(2)*0.125,fill=%t,color=color(192,192,192));
    end
    if orient then
      xstring(orig(1)+sz(1)*-0.14,orig(2)+sz(2)*0.65,model.label,w=sz(1)*1.305,h=sz(2)*0.24,fill=%t,color=color(0,0,0));
    else
      xstring(orig(1)+sz(1)*(-0.165),orig(2)+sz(2)*0.65,model.label,w=sz(1)*1.305,h=sz(2)*0.24,fill=%t,color=color(0,0,0));
    end
  endfunction

x=[];y=[];typ=[];

select job
  case 'plot' then
    standard_draw(arg1,%f,_CMPSR_Position2_dp);
  case 'getinputs' then
    [x,y,typ]=_CMPSR_Position2_ip(arg1);
  case 'getoutputs' then
    [x,y,typ]=_CMPSR_Position2_op(arg1);
  case 'getorigin' then
    [x,y]=standard_origin(arg1);
  case 'set' then
    x=arg1;
  case 'define' then
    model=scicos_model();
    model.sim='Coselica';
    model.blocktype='c';
    model.dep_ut=[%t %f];
    model.in=[1;1];
    model.out=[1;2];
    mo=modelica();
      mo.model='Coselica.Mechanics.Planar.Sensors.Relative.Position2';
      mo.inputs=['frame_a','frame_resolve'];
      mo.outputs=['frame_b','y'];
      mo.parameters=list([],list(),[]);
    model.equations=mo;
    exprs=[];
    gr_i="blk_draw(sz,orig,orient,model.label)";
    x=standard_define([2 2],model,exprs,list(gr_i,0));
    x.graphics.in_implicit=['I','I'];
    x.graphics.out_implicit=['I','I'];
  end
endfunction
