// Coselica Toolbox for Scicos/Nsp
// Copyright (C) 2009-2016  Dirk Reusch, Kybernetik Dr. Reusch
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

function [x,y,typ]=CMRC_BearingFriction(job,arg1,arg2)

  function blk_draw(sz,orig,orient,label)
    if orient then
      xx=orig(1);yy=orig(2);
      ww=sz(1);hh=sz(2);
    else
      xx=orig(1)+sz(1);yy=orig(2);
      ww=-sz(1);hh=sz(2);
    end
    if orient then
      xrect(orig(1)+sz(1)*0,orig(2)+sz(2)*0.55,sz(1)*1,sz(2)*0.1,color=color(0,0,0),background=color(192,192,192),thickness=0.25);
    else
      xrect(orig(1)+sz(1)*(1-0-1),orig(2)+sz(2)*0.55,sz(1)*1,sz(2)*0.1,color=color(0,0,0),background=color(192,192,192),thickness=0.25);
    end
    if orient then
      xrect(orig(1)+sz(1)*0.2,orig(2)+sz(2)*0.45,sz(1)*0.6,sz(2)*0.25,color=color(0,0,0),background=color(0,0,0),thickness=0.25);
    else
      xrect(orig(1)+sz(1)*(1-0.2-0.6),orig(2)+sz(2)*0.45,sz(1)*0.6,sz(2)*0.25,color=color(0,0,0),background=color(0,0,0),thickness=0.25);
    end
    if orient then
      xrect(orig(1)+sz(1)*0.2,orig(2)+sz(2)*0.45,sz(1)*0.6,sz(2)*0.075,color=color(0,0,0),background=color(192,192,192),thickness=0.25);
    else
      xrect(orig(1)+sz(1)*(1-0.2-0.6),orig(2)+sz(2)*0.45,sz(1)*0.6,sz(2)*0.075,color=color(0,0,0),background=color(192,192,192),thickness=0.25);
    end
    if orient then
      xrect(orig(1)+sz(1)*0.2,orig(2)+sz(2)*0.275,sz(1)*0.6,sz(2)*0.08,color=color(0,0,0),background=color(192,192,192),thickness=0.25);
    else
      xrect(orig(1)+sz(1)*(1-0.2-0.6),orig(2)+sz(2)*0.275,sz(1)*0.6,sz(2)*0.08,color=color(0,0,0),background=color(192,192,192),thickness=0.25);
    end
    if orient then
      xrect(orig(1)+sz(1)*0.25,orig(2)+sz(2)*0.41,sz(1)*0.5,sz(2)*0.16,color=color(0,0,0),background=color(255,255,255),thickness=0.25);
    else
      xrect(orig(1)+sz(1)*(1-0.25-0.5),orig(2)+sz(2)*0.41,sz(1)*0.5,sz(2)*0.16,color=color(0,0,0),background=color(255,255,255),thickness=0.25);
    end
    xfpoly(xx+ww*[0.8;0.8;0.875;0.875;0.125;0.125;0.2;0.2;0.8],yy+hh*[0.2;0.15;0.15;0.1;0.1;0.15;0.15;0.2;0.2],color=color(0,0,0),fill_color=color(160,160,160),thickness=0.25);
    xpoly(xx+ww*[0.125;0.125],yy+hh*[0.45;0.15],color=color(0,0,0),thickness=0.25);
    xpoly(xx+ww*[0.875;0.875],yy+hh*[0.45;0.15],color=color(0,0,0),thickness=0.25);
    if orient then
      xrect(orig(1)+sz(1)*0.2,orig(2)+sz(2)*0.8,sz(1)*0.6,sz(2)*0.25,color=color(0,0,0),background=color(0,0,0),thickness=0.25);
    else
      xrect(orig(1)+sz(1)*(1-0.2-0.6),orig(2)+sz(2)*0.8,sz(1)*0.6,sz(2)*0.25,color=color(0,0,0),background=color(0,0,0),thickness=0.25);
    end
    if orient then
      xrect(orig(1)+sz(1)*0.2,orig(2)+sz(2)*0.8,sz(1)*0.6,sz(2)*0.075,color=color(0,0,0),background=color(192,192,192),thickness=0.25);
    else
      xrect(orig(1)+sz(1)*(1-0.2-0.6),orig(2)+sz(2)*0.8,sz(1)*0.6,sz(2)*0.075,color=color(0,0,0),background=color(192,192,192),thickness=0.25);
    end
    if orient then
      xrect(orig(1)+sz(1)*0.2,orig(2)+sz(2)*0.625,sz(1)*0.6,sz(2)*0.075,color=color(0,0,0),background=color(192,192,192),thickness=0.25);
    else
      xrect(orig(1)+sz(1)*(1-0.2-0.6),orig(2)+sz(2)*0.625,sz(1)*0.6,sz(2)*0.075,color=color(0,0,0),background=color(192,192,192),thickness=0.25);
    end
    if orient then
      xrect(orig(1)+sz(1)*0.25,orig(2)+sz(2)*0.755,sz(1)*0.5,sz(2)*0.16,color=color(0,0,0),background=color(255,255,255),thickness=0.25);
    else
      xrect(orig(1)+sz(1)*(1-0.25-0.5),orig(2)+sz(2)*0.755,sz(1)*0.5,sz(2)*0.16,color=color(0,0,0),background=color(255,255,255),thickness=0.25);
    end
    xpoly(xx+ww*[0.125;0.125],yy+hh*[0.85;0.55],color=color(0,0,0),thickness=0.25);
    xfpoly(xx+ww*[0.8;0.8;0.875;0.875;0.125;0.125;0.2;0.2;0.8],yy+hh*[0.8;0.85;0.85;0.9;0.9;0.85;0.85;0.8;0.8],color=color(0,0,0),fill_color=color(160,160,160),thickness=0.25);
    xpoly(xx+ww*[0.875;0.875],yy+hh*[0.85;0.55],color=color(0,0,0),thickness=0.25);
    if orient then
      xstring(orig(1)+sz(1)*0,orig(2)+sz(2)*0.95,model.label,w=sz(1)*1,h=sz(2)*0.2,fill=%t,color=color(0,0,0));
    else
      xstring(orig(1)+sz(1)*(0),orig(2)+sz(2)*0.95,model.label,w=sz(1)*1,h=sz(2)*0.2,fill=%t,color=color(0,0,0));
    end
    xpoly(xx+ww*[0.45;0.5],yy+hh*[0.05;0.1],color=color(0,0,0),thickness=0.25);
    xpoly(xx+ww*[0.475;0.525],yy+hh*[0.05;0.1],color=color(0,0,0),thickness=0.25);
    xpoly(xx+ww*[0.5;0.55],yy+hh*[0.05;0.1],color=color(0,0,0),thickness=0.25);
    xpoly(xx+ww*[0.525;0.55],yy+hh*[0.05;0.075],color=color(0,0,0),thickness=0.25);
    xpoly(xx+ww*[0.45;0.475],yy+hh*[0.075;0.1],color=color(0,0,0),thickness=0.25);
    xpoly(xx+ww*[0.5;0.5],yy+hh*[0.05;0],color=color(0,0,0),thickness=0.25);
  endfunction

x=[];y=[];typ=[];

select job
  case 'plot' then
    Tau_prop=arg1.graphics.exprs(1);
    Tau_Coulomb=arg1.graphics.exprs(2);
    Tau_Stribeck=arg1.graphics.exprs(3);
    fexp=arg1.graphics.exprs(4);
    mode_start=arg1.graphics.exprs(5);
    standard_draw(arg1,%f,_CMRC_IdealGear_dp);
  case 'getinputs' then
    [x,y,typ]=_CMRC_IdealGear_ip(arg1);
  case 'getoutputs' then
    [x,y,typ]=_CMRC_IdealGear_op(arg1);
  case 'getorigin' then
    [x,y]=standard_origin(arg1);
  case 'set' then
    x=arg1;
    graphics=arg1.graphics;exprs=graphics.exprs;
    model=arg1.model;
    while %t do
      [ok,Tau_prop,Tau_Coulomb,Tau_Stribeck,fexp,mode_start,exprs]=..
        getvalue(['';'CMRC_BearingFriction';'';'Coulomb friction with Stribeck effect in bearings';''],..
        [' Tau_prop [N.m/(rad/s)] : Angular velocity dependent friction',' Tau_Coulomb [N.m] : Constant fricton: Coulomb torque',' Tau_Stribeck [N.m] : Stribeck effect',' fexp [1/(rad/s)] : Exponential decay of Stribeck effect',' mode_start [-] : Initial sliding mode (-1=Backward,0=Sticking,1=Forward,2=Free)'],..
        list('vec',1,'vec',1,'vec',1,'vec',1,'vec',1),exprs);
      if ~ok then break, end
      model.equations.parameters(2)=list(Tau_prop,Tau_Coulomb,Tau_Stribeck,fexp,mode_start)
      model.in=[1];
      model.out=[1;1];
      graphics.exprs=exprs;
      x.graphics=graphics;x.model=model;
      break
    end
  case 'define' then
    Tau_prop=1;
    Tau_Coulomb=5;
    Tau_Stribeck=10;
    fexp=2;
    mode_start=0;
    model=scicos_model();
    model.sim='Coselica';
    model.blocktype='c';
    model.dep_ut=[%t %f];
    model.in=[1];
    model.out=[1;1];
    mo=modelica();
      mo.model='Coselica.Mechanics.Rotational.Components.BearingFriction';
      mo.inputs=['flange_a'];
      mo.outputs=['flange_b','bearing'];
      mo.parameters=list(['Tau_prop','Tau_Coulomb','Tau_Stribeck','fexp','mode_start'],..
                         list(Tau_prop,Tau_Coulomb,Tau_Stribeck,fexp,mode_start),..
                         [0,0,0,0,0]);
    model.equations=mo;
    exprs=[strcat(sci2exp(Tau_prop));strcat(sci2exp(Tau_Coulomb));strcat(sci2exp(Tau_Stribeck));strcat(sci2exp(fexp));strcat(sci2exp(mode_start))];
    gr_i="blk_draw(sz,orig,orient,model.label)";
    x=standard_define([2 2],model,exprs,list(gr_i,0));
    x.graphics.in_implicit=['I'];
    x.graphics.out_implicit=['I','I'];
  end
endfunction
