// Coselica Toolbox for Scicos/Nsp
// Copyright (C) 2009-2016  Dirk Reusch, Kybernetik Dr. Reusch
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

function [x,y,typ]=CMRC_Fixed(job,arg1,arg2)

  function blk_draw(sz,orig,orient,label)
    if orient then
      xx=orig(1);yy=orig(2);
      ww=sz(1);hh=sz(2);
    else
      xx=orig(1)+sz(1);yy=orig(2);
      ww=-sz(1);hh=sz(2);
    end
    if orient then
      xstring(orig(1)+sz(1)*-0.25,orig(2)+sz(2)*-0.15,model.label,w=sz(1)*1.5,h=sz(2)*0.2,fill=%t,color=color(0,0,255));
    else
      xstring(orig(1)+sz(1)*(-0.25),orig(2)+sz(2)*-0.15,model.label,w=sz(1)*1.5,h=sz(2)*0.2,fill=%t,color=color(0,0,255));
    end
    xpoly(xx+ww*[0.1;0.9],yy+hh*[0.3;0.3],color=color(0,0,0),thickness=0.25);
    xpoly(xx+ww*[0.9;0.7],yy+hh*[0.3;0.1],color=color(0,0,0),thickness=0.25);
    xpoly(xx+ww*[0.7;0.5],yy+hh*[0.3;0.1],color=color(0,0,0),thickness=0.25);
    xpoly(xx+ww*[0.5;0.3],yy+hh*[0.3;0.1],color=color(0,0,0),thickness=0.25);
    xpoly(xx+ww*[0.3;0.1],yy+hh*[0.3;0.1],color=color(0,0,0),thickness=0.25);
    xpoly(xx+ww*[0.5;0.5],yy+hh*[0.3;0.45],color=color(0,0,0),thickness=0.25);
  endfunction

x=[];y=[];typ=[];

select job
  case 'plot' then
    phi0=arg1.graphics.exprs(1);
    standard_draw(arg1,%f,_CMRC_Fixed_dp);
  case 'getinputs' then
    [x,y,typ]=_CMRC_Fixed_ip(arg1);
  case 'getoutputs' then
    [x,y,typ]=_CMRC_Fixed_op(arg1);
  case 'getorigin' then
    [x,y]=standard_origin(arg1);
  case 'set' then
    x=arg1;
    graphics=arg1.graphics;exprs=graphics.exprs;
    model=arg1.model;
    while %t do
      [ok,phi0,exprs]=..
        getvalue(['';'CMRC_Fixed';'';'Flange fixed in housing at a given angle';''],..
        [' phi0 [rad] : Fixed offset angle of housing'],..
        list('vec',1),exprs);
      if ~ok then break, end
      model.equations.parameters(2)=list(phi0)
      model.in=[];
      model.out=[1];
      graphics.exprs=exprs;
      x.graphics=graphics;x.model=model;
      break
    end
  case 'define' then
    phi0=0;
    model=scicos_model();
    model.sim='Coselica';
    model.blocktype='c';
    model.dep_ut=[%t %f];
    model.in=[];
    model.out=[1];
    mo=modelica();
      mo.model='Coselica.Mechanics.Rotational.Components.Fixed';
      mo.inputs=[];
      mo.outputs=['flange_b'];
      mo.parameters=list(['phi0'],..
                         list(phi0),..
                         [0]);
    model.equations=mo;
    exprs=[strcat(sci2exp(phi0))];
    gr_i="blk_draw(sz,orig,orient,model.label)";
    x=standard_define([2 2],model,exprs,list(gr_i,0));
    x.graphics.in_implicit=[];
    x.graphics.out_implicit=['I'];
  end
endfunction
