// Coselica Toolbox for Scicos/Nsp
// Copyright (C) 2009-2016  Dirk Reusch, Kybernetik Dr. Reusch
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

function [x,y,typ]=CMRS_Torque0(job,arg1,arg2)

  function blk_draw(sz,orig,orient,label)
    if orient then
      xx=orig(1);yy=orig(2);
      ww=sz(1);hh=sz(2);
    else
      xx=orig(1)+sz(1);yy=orig(2);
      ww=-sz(1);hh=sz(2);
    end
    if orient then
      xstring(orig(1)+sz(1)*-0.25,orig(2)+sz(2)*0.85,model.label,w=sz(1)*1.5,h=sz(2)*0.2,fill=%t,color=color(0,0,255));
    else
      xstring(orig(1)+sz(1)*(-0.25),orig(2)+sz(2)*0.85,model.label,w=sz(1)*1.5,h=sz(2)*0.2,fill=%t,color=color(0,0,255));
    end
    if orient then
      xstring(orig(1)+sz(1)*-0.205,orig(2)+sz(2)*0.15,"tau",w=sz(1)*0.395,h=sz(2)*0.205,fill=%t,color=color(0,0,0));
    else
      xstring(orig(1)+sz(1)*(0.81),orig(2)+sz(2)*0.15,"tau",w=sz(1)*0.395,h=sz(2)*0.205,fill=%t,color=color(0,0,0));
    end
    xpoly(xx+ww*[0.06;0.18;0.32;0.49;0.64;0.74;0.82;0.88;0.93],yy+hh*[0.5;0.65;0.76;0.81;0.78;0.72;0.64;0.57;0.5],color=color(0,0,0),thickness=0.5);
    xfpoly(xx+ww*[0.93;0.83;0.685;0.93],yy+hh*[0.5;0.79;0.635;0.5],color=color(0,0,0),fill_color=color(0,0,0),thickness=0.25);
    xpoly(xx+ww*[0.35;0.65],yy+hh*[0.35;0.35],color=color(0,0,0),thickness=0.25);
    xpoly(xx+ww*[0.35;0.45],yy+hh*[0.25;0.35],color=color(0,0,0),thickness=0.25);
    xpoly(xx+ww*[0.45;0.55],yy+hh*[0.25;0.35],color=color(0,0,0),thickness=0.25);
    xpoly(xx+ww*[0.55;0.65],yy+hh*[0.25;0.35],color=color(0,0,0),thickness=0.25);
    xpoly(xx+ww*[0.23;0.31;0.42;0.52;0.61;0.68;0.74;0.78;0.82],yy+hh*[0.29;0.36;0.42;0.43;0.41;0.37;0.32;0.27;0.21],color=color(0,0,0),thickness=0.25);
    xfpoly(xx+ww*[0.195;0.28;0.21;0.195],yy+hh*[0.17;0.29;0.32;0.17],color=color(0,0,0),fill_color=color(0,0,0),thickness=0.25);
  endfunction

x=[];y=[];typ=[];

select job
  case 'plot' then
    standard_draw(arg1,%f,_CMRS_Position0_dp);
  case 'getinputs' then
    [x,y,typ]=_CMRS_Position0_ip(arg1);
  case 'getoutputs' then
    [x,y,typ]=_CMRS_Position0_op(arg1);
  case 'getorigin' then
    [x,y]=standard_origin(arg1);
  case 'set' then
    x=arg1;
  case 'define' then
    model=scicos_model();
    model.sim='Coselica';
    model.blocktype='c';
    model.dep_ut=[%t %f];
    model.in=[1];
    model.out=[1];
    mo=modelica();
      mo.model='Coselica.Mechanics.Rotational.Sources.Torque0';
      mo.inputs=['tau'];
      mo.outputs=['flange_b'];
      mo.parameters=list([],list(),[]);
    model.equations=mo;
    exprs=[];
    gr_i="blk_draw(sz,orig,orient,model.label)";
    x=standard_define([2 2],model,exprs,list(gr_i,0));
    x.graphics.in_implicit=['E'];
    x.graphics.out_implicit=['I'];
  end
endfunction
