// Coselica Toolbox for Scicos/Nsp
// Copyright (C) 2009-2016  Dirk Reusch, Kybernetik Dr. Reusch
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

function [x,y,typ]=CMRS_Torque2(job,arg1,arg2)

  function blk_draw(sz,orig,orient,label)
    if orient then
      xx=orig(1);yy=orig(2);
      ww=sz(1);hh=sz(2);
    else
      xx=orig(1)+sz(1);yy=orig(2);
      ww=-sz(1);hh=sz(2);
    end
    if orient then
      xstring(orig(1)+sz(1)*-0.25,orig(2)+sz(2)*0.1,model.label,w=sz(1)*1.5,h=sz(2)*0.2,fill=%t,color=color(0,0,255));
    else
      xstring(orig(1)+sz(1)*(-0.25),orig(2)+sz(2)*0.1,model.label,w=sz(1)*1.5,h=sz(2)*0.2,fill=%t,color=color(0,0,255));
    end
    xfpoly(xx+ww*[0.055;0.1;0;0.055],yy+hh*[0.62;0.585;0.5;0.62],color=color(0,0,0),fill_color=color(0,0,0),thickness=0.5);
    xpoly(xx+ww*[0.075;0.095;0.12;0.145;0.165;0.195;0.24;0.27;0.29;0.315;0.34;0.36;0.38;0.395],yy+hh*[0.6;0.615;0.63;0.64;0.645;0.65;0.65;0.645;0.64;0.63;0.615;0.6;0.575;0.545],color=color(0,0,0),thickness=0.5);
    xpoly(xx+ww*[0.925;0.905;0.88;0.855;0.835;0.805;0.76;0.73;0.71;0.685;0.66;0.64;0.62;0.605],yy+hh*[0.6;0.615;0.63;0.64;0.645;0.65;0.65;0.645;0.64;0.63;0.615;0.6;0.575;0.545],color=color(0,0,0),thickness=0.5);
    xfpoly(xx+ww*[1;0.945;0.905;1],yy+hh*[0.5;0.62;0.585;0.5],color=color(0,0,0),fill_color=color(0,0,0),thickness=0.25);
  endfunction

x=[];y=[];typ=[];

select job
  case 'plot' then
    standard_draw(arg1,%f,_CMRS_Torque2_dp);
  case 'getinputs' then
    [x,y,typ]=_CMRS_Torque2_ip(arg1);
  case 'getoutputs' then
    [x,y,typ]=_CMRS_Torque2_op(arg1);
  case 'getorigin' then
    [x,y]=standard_origin(arg1);
  case 'set' then
    x=arg1;
  case 'define' then
    model=scicos_model();
    model.sim='Coselica';
    model.blocktype='c';
    model.dep_ut=[%t %f];
    model.in=[1;1];
    model.out=[1];
    mo=modelica();
      mo.model='Coselica.Mechanics.Rotational.Sources.Torque2';
      mo.inputs=['flange_a','tau'];
      mo.outputs=['flange_b'];
      mo.parameters=list([],list(),[]);
    model.equations=mo;
    exprs=[];
    gr_i="blk_draw(sz,orig,orient,model.label)";
    x=standard_define([2 2],model,exprs,list(gr_i,0));
    x.graphics.in_implicit=['I','I'];
    x.graphics.out_implicit=['I'];
  end
endfunction
