// Coselica Toolbox for Scicos/Nsp
// Copyright (C) 2009-2016  Dirk Reusch, Kybernetik Dr. Reusch
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

function [x,y,typ]=CTHC_BodyRadiation(job,arg1,arg2)

  function blk_draw(sz,orig,orient,label)
    if orient then
      xx=orig(1);yy=orig(2);
      ww=sz(1);hh=sz(2);
    else
      xx=orig(1)+sz(1);yy=orig(2);
      ww=-sz(1);hh=sz(2);
    end
    if orient then
      xrect(orig(1)+sz(1)*0.75,orig(2)+sz(2)*0.9,sz(1)*0.2,sz(2)*0.8,color=color(0,0,0),background=color(192,192,192),thickness=0.25);
    else
      xrect(orig(1)+sz(1)*(1-0.75-0.2),orig(2)+sz(2)*0.9,sz(1)*0.2,sz(2)*0.8,color=color(0,0,0),background=color(192,192,192),thickness=0.25);
    end
    if orient then
      xrect(orig(1)+sz(1)*0.05,orig(2)+sz(2)*0.9,sz(1)*0.2,sz(2)*0.8,color=color(0,0,0),background=color(192,192,192),thickness=0.25);
    else
      xrect(orig(1)+sz(1)*(1-0.05-0.2),orig(2)+sz(2)*0.9,sz(1)*0.2,sz(2)*0.8,color=color(0,0,0),background=color(192,192,192),thickness=0.25);
    end
    xpoly(xx+ww*[0.32;0.68],yy+hh*[0.55;0.55],color=color(191,0,0),thickness=0.25);
    xpoly(xx+ww*[0.32;0.37],yy+hh*[0.55;0.58],color=color(191,0,0),thickness=0.25);
    xpoly(xx+ww*[0.32;0.37],yy+hh*[0.55;0.52],color=color(191,0,0),thickness=0.25);
    xpoly(xx+ww*[0.32;0.68],yy+hh*[0.45;0.45],color=color(191,0,0),thickness=0.25);
    xpoly(xx+ww*[0.63;0.68],yy+hh*[0.42;0.45],color=color(191,0,0),thickness=0.25);
    xpoly(xx+ww*[0.63;0.68],yy+hh*[0.48;0.45],color=color(191,0,0),thickness=0.25);
    xpoly(xx+ww*[0.32;0.68],yy+hh*[0.35;0.35],color=color(191,0,0),thickness=0.25);
    xpoly(xx+ww*[0.32;0.37],yy+hh*[0.35;0.38],color=color(191,0,0),thickness=0.25);
    xpoly(xx+ww*[0.32;0.37],yy+hh*[0.35;0.32],color=color(191,0,0),thickness=0.25);
    xpoly(xx+ww*[0.32;0.68],yy+hh*[0.65;0.65],color=color(191,0,0),thickness=0.25);
    xpoly(xx+ww*[0.63;0.68],yy+hh*[0.62;0.65],color=color(191,0,0),thickness=0.25);
    xpoly(xx+ww*[0.63;0.68],yy+hh*[0.68;0.65],color=color(191,0,0),thickness=0.25);
    if orient then
      xstring(orig(1)+sz(1)*-0.16,orig(2)+sz(2)*0.92,model.label,w=sz(1)*1.2,h=sz(2)*0.3,fill=%t,color=color(0,0,255));
    else
      xstring(orig(1)+sz(1)*(-0.04),orig(2)+sz(2)*0.92,model.label,w=sz(1)*1.2,h=sz(2)*0.3,fill=%t,color=color(0,0,255));
    end
    if orient then
      xstring(orig(1)+sz(1)*-0.095,orig(2)+sz(2)*-0.125,"Gr="+string(Gr)+"",w=sz(1)*1.18,h=sz(2)*0.195,fill=%t,color=color(0,0,0));
    else
      xstring(orig(1)+sz(1)*(-0.085),orig(2)+sz(2)*-0.125,"Gr="+string(Gr)+"",w=sz(1)*1.18,h=sz(2)*0.195,fill=%t,color=color(0,0,0));
    end
    if orient then
      xrect(orig(1)+sz(1)*0.25,orig(2)+sz(2)*0.9,sz(1)*0.03,sz(2)*0.8,color=color(191,0,0),background=color(191,0,0),thickness=0.25);
    else
      xrect(orig(1)+sz(1)*(1-0.25-0.03),orig(2)+sz(2)*0.9,sz(1)*0.03,sz(2)*0.8,color=color(191,0,0),background=color(191,0,0),thickness=0.25);
    end
    if orient then
      xrect(orig(1)+sz(1)*0.725,orig(2)+sz(2)*0.9,sz(1)*0.025,sz(2)*0.8,color=color(191,0,0),background=color(191,0,0),thickness=0.25);
    else
      xrect(orig(1)+sz(1)*(1-0.725-0.025),orig(2)+sz(2)*0.9,sz(1)*0.025,sz(2)*0.8,color=color(191,0,0),background=color(191,0,0),thickness=0.25);
    end
  endfunction

x=[];y=[];typ=[];

select job
  case 'plot' then
    Gr=arg1.graphics.exprs(1);
    standard_draw(arg1,%f,_MTHI_Element1D_dp);
  case 'getinputs' then
    [x,y,typ]=_MTHI_Element1D_ip(arg1);
  case 'getoutputs' then
    [x,y,typ]=_MTHI_Element1D_op(arg1);
  case 'getorigin' then
    [x,y]=standard_origin(arg1);
  case 'set' then
    x=arg1;
    graphics=arg1.graphics;exprs=graphics.exprs;
    model=arg1.model;
    while %t do
      [ok,Gr,exprs]=..
        getvalue(['';'CTHC_BodyRadiation';'';'Lumped thermal element for radiation heat transfer';''],..
        [' Gr [m2] : Net radiation conductance between two surfaces (see help)'],..
        list('vec',1),exprs);
      if ~ok then break, end
      model.equations.parameters(2)=list(Gr)
      model.in=[1];
      model.out=[1];
      graphics.exprs=exprs;
      x.graphics=graphics;x.model=model;
      break
    end
  case 'define' then
    Gr=1;
    model=scicos_model();
    model.sim='Coselica';
    model.blocktype='c';
    model.dep_ut=[%t %f];
    model.in=[1];
    model.out=[1];
    mo=modelica();
      mo.model='Coselica.Thermal.HeatTransfer.Components.BodyRadiation';
      mo.inputs=['port_a'];
      mo.outputs=['port_b'];
      mo.parameters=list(['Gr'],..
                         list(Gr),..
                         [0]);
    model.equations=mo;
    exprs=[strcat(sci2exp(Gr))];
    gr_i="blk_draw(sz,orig,orient,model.label)";
    x=standard_define([2 2],model,exprs,list(gr_i,0));
    x.graphics.in_implicit=['I'];
    x.graphics.out_implicit=['I'];
  end
endfunction
