// Coselica Toolbox for Scicos/Nsp
// Copyright (C) 2009-2016  Dirk Reusch, Kybernetik Dr. Reusch
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

function [x,y,typ]=CTHC_Convection(job,arg1,arg2)

  function blk_draw(sz,orig,orient,label)
    if orient then
      xx=orig(1);yy=orig(2);
      ww=sz(1);hh=sz(2);
    else
      xx=orig(1)+sz(1);yy=orig(2);
      ww=-sz(1);hh=sz(2);
    end
    if orient then
      xrect(orig(1)+sz(1)*0.19,orig(2)+sz(2)*0.95,sz(1)*0.76,sz(2)*0.9,color=color(255,255,255),background=color(255,255,255),thickness=0.25);
    else
      xrect(orig(1)+sz(1)*(1-0.19-0.76),orig(2)+sz(2)*0.95,sz(1)*0.76,sz(2)*0.9,color=color(255,255,255),background=color(255,255,255),thickness=0.25);
    end
    if orient then
      xrect(orig(1)+sz(1)*0.05,orig(2)+sz(2)*0.95,sz(1)*0.15,sz(2)*0.9,color=color(0,0,0),background=color(192,192,192),thickness=0.25);
    else
      xrect(orig(1)+sz(1)*(1-0.05-0.15),orig(2)+sz(2)*0.95,sz(1)*0.15,sz(2)*0.9,color=color(0,0,0),background=color(192,192,192),thickness=0.25);
    end
    if orient then
      xstring(orig(1)+sz(1)*-0.085,orig(2)+sz(2)*-0.14,model.label,w=sz(1)*1.205,h=sz(2)*0.2,fill=%t,color=color(0,0,255));
    else
      xstring(orig(1)+sz(1)*(-0.12),orig(2)+sz(2)*-0.14,model.label,w=sz(1)*1.205,h=sz(2)*0.2,fill=%t,color=color(0,0,255));
    end
    xpoly(xx+ww*[1;1],yy+hh*[0.5;0.5],color=color(0,127,255),thickness=0.25);
    xpoly(xx+ww*[0.2;0.88],yy+hh*[0.6;0.6],color=color(191,0,0),thickness=0.25);
    xpoly(xx+ww*[0.2;0.88],yy+hh*[0.4;0.4],color=color(191,0,0),thickness=0.25);
    xpoly(xx+ww*[0.33;0.33],yy+hh*[0.95;0.05],color=color(0,127,255),thickness=0.25);
    xpoly(xx+ww*[0.53;0.53],yy+hh*[0.95;0.05],color=color(0,127,255),thickness=0.25);
    xpoly(xx+ww*[0.7;0.7],yy+hh*[0.95;0.05],color=color(0,127,255),thickness=0.25);
    xpoly(xx+ww*[0.88;0.88],yy+hh*[0.95;0.05],color=color(0,127,255),thickness=0.25);
    xpoly(xx+ww*[0.33;0.28],yy+hh*[0.05;0.2],color=color(0,127,255),thickness=0.25);
    xpoly(xx+ww*[0.33;0.38],yy+hh*[0.05;0.2],color=color(0,127,255),thickness=0.25);
    xpoly(xx+ww*[0.53;0.48],yy+hh*[0.05;0.2],color=color(0,127,255),thickness=0.25);
    xpoly(xx+ww*[0.53;0.58],yy+hh*[0.05;0.2],color=color(0,127,255),thickness=0.25);
    xpoly(xx+ww*[0.7;0.65],yy+hh*[0.05;0.2],color=color(0,127,255),thickness=0.25);
    xpoly(xx+ww*[0.7;0.75],yy+hh*[0.05;0.2],color=color(0,127,255),thickness=0.25);
    xpoly(xx+ww*[0.88;0.83],yy+hh*[0.05;0.2],color=color(0,127,255),thickness=0.25);
    xpoly(xx+ww*[0.88;0.93],yy+hh*[0.05;0.2],color=color(0,127,255),thickness=0.25);
    xpoly(xx+ww*[0.78;0.88],yy+hh*[0.35;0.4],color=color(191,0,0),thickness=0.25);
    xpoly(xx+ww*[0.78;0.88],yy+hh*[0.45;0.4],color=color(191,0,0),thickness=0.25);
    xpoly(xx+ww*[0.78;0.88],yy+hh*[0.55;0.6],color=color(191,0,0),thickness=0.25);
    xpoly(xx+ww*[0.78;0.88],yy+hh*[0.65;0.6],color=color(191,0,0),thickness=0.25);
  endfunction

x=[];y=[];typ=[];

select job
  case 'plot' then
    standard_draw(arg1,%f,_CTHC_Convection_dp);
  case 'getinputs' then
    [x,y,typ]=_CTHC_Convection_ip(arg1);
  case 'getoutputs' then
    [x,y,typ]=_CTHC_Convection_op(arg1);
  case 'getorigin' then
    [x,y]=standard_origin(arg1);
  case 'set' then
    x=arg1;
  case 'define' then
    model=scicos_model();
    model.sim='Coselica';
    model.blocktype='c';
    model.dep_ut=[%t %f];
    model.in=[1;1];
    model.out=[1];
    mo=modelica();
      mo.model='Coselica.Thermal.HeatTransfer.Components.Convection';
      mo.inputs=['solid','Gc'];
      mo.outputs=['fluid'];
      mo.parameters=list([],list(),[]);
    model.equations=mo;
    exprs=[];
    gr_i="blk_draw(sz,orig,orient,model.label)";
    x=standard_define([2 2],model,exprs,list(gr_i,0));
    x.graphics.in_implicit=['I','I'];
    x.graphics.out_implicit=['I'];
  end
endfunction
