// Coselica Toolbox for Scicos/Nsp
// Copyright (C) 2009-2016  Dirk Reusch, Kybernetik Dr. Reusch
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

function [x,y,typ]=CTHC_FixedTemperature(job,arg1,arg2)

  function blk_draw(sz,orig,orient,label)
    if orient then
      xx=orig(1);yy=orig(2);
      ww=sz(1);hh=sz(2);
    else
      xx=orig(1)+sz(1);yy=orig(2);
      ww=-sz(1);hh=sz(2);
    end
    if orient then
      xstring(orig(1)+sz(1)*-0.09,orig(2)+sz(2)*1.025,model.label,w=sz(1)*1.2,h=sz(2)*0.3,fill=%t,color=color(0,0,255));
    else
      xstring(orig(1)+sz(1)*(-0.11),orig(2)+sz(2)*1.025,model.label,w=sz(1)*1.2,h=sz(2)*0.3,fill=%t,color=color(0,0,255));
    end
    if orient then
      xrect(orig(1)+sz(1)*0,orig(2)+sz(2)*1,sz(1)*1,sz(2)*1,color=color(0,0,0),background=color(159,159,223),thickness=0.25);
    else
      xrect(orig(1)+sz(1)*(1-0-1),orig(2)+sz(2)*1,sz(1)*1,sz(2)*1,color=color(0,0,0),background=color(159,159,223),thickness=0.25);
    end
    if orient then
      xstring(orig(1)+sz(1)*0,orig(2)+sz(2)*0,"C",w=sz(1)*0.5,h=sz(2)*0.5,fill=%t,color=color(0,0,0));
    else
      xstring(orig(1)+sz(1)*(0.5),orig(2)+sz(2)*0,"C",w=sz(1)*0.5,h=sz(2)*0.5,fill=%t,color=color(0,0,0));
    end
    xfpoly(xx+ww*[0.76;0.76;0.95;0.76],yy+hh*[0.4;0.6;0.5;0.4],color=color(191,0,0),fill_color=color(191,0,0),thickness=0.25);
    if orient then
      xstring(orig(1)+sz(1)*-0.225,orig(2)+sz(2)*-0.255,"T="+string(T)+"",w=sz(1)*1.4,h=sz(2)*0.245,fill=%t,color=color(0,0,0));
    else
      xstring(orig(1)+sz(1)*(-0.175),orig(2)+sz(2)*-0.255,"T="+string(T)+"",w=sz(1)*1.4,h=sz(2)*0.245,fill=%t,color=color(0,0,0));
    end
    xpoly(xx+ww*[0.29;0.83],yy+hh*[0.5;0.5],color=color(191,0,0),thickness=0.5);
  endfunction

x=[];y=[];typ=[];

select job
  case 'plot' then
    T=arg1.graphics.exprs(1);
    standard_draw(arg1,%f,_CTHS_FixedTemperature_dp);
  case 'getinputs' then
    [x,y,typ]=_CTHS_FixedTemperature_ip(arg1);
  case 'getoutputs' then
    [x,y,typ]=_CTHS_FixedTemperature_op(arg1);
  case 'getorigin' then
    [x,y]=standard_origin(arg1);
  case 'set' then
    x=arg1;
    graphics=arg1.graphics;exprs=graphics.exprs;
    model=arg1.model;
    while %t do
      [ok,T,exprs]=..
        getvalue(['';'CTHC_FixedTemperature';'';'Fixed temperature boundary condition in degree Celsius';''],..
        [' T [degC] : Fixed Temperature at the port'],..
        list('vec',1),exprs);
      if ~ok then break, end
      model.equations.parameters(2)=list(T)
      model.in=[];
      model.out=[1];
      graphics.exprs=exprs;
      x.graphics=graphics;x.model=model;
      break
    end
  case 'define' then
    T=20;
    model=scicos_model();
    model.sim='Coselica';
    model.blocktype='c';
    model.dep_ut=[%t %f];
    model.in=[];
    model.out=[1];
    mo=modelica();
      mo.model='Coselica.Thermal.HeatTransfer.Celsius.FixedTemperature';
      mo.inputs=[];
      mo.outputs=['port'];
      mo.parameters=list(['T'],..
                         list(T),..
                         [0]);
    model.equations=mo;
    exprs=[strcat(sci2exp(T))];
    gr_i="blk_draw(sz,orig,orient,model.label)";
    x=standard_define([2 2],model,exprs,list(gr_i,0));
    x.graphics.in_implicit=[];
    x.graphics.out_implicit=['I'];
  end
endfunction
