// Coselica Toolbox for Scicos/Nsp
// Copyright (C) 2009-2016  Dirk Reusch, Kybernetik Dr. Reusch
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

function [x,y,typ]=CTHC_TemperatureSensor(job,arg1,arg2)

  function blk_draw(sz,orig,orient,label)
    if orient then
      xx=orig(1);yy=orig(2);
      ww=sz(1);hh=sz(2);
    else
      xx=orig(1)+sz(1);yy=orig(2);
      ww=-sz(1);hh=sz(2);
    end
    if orient then
      xarc(orig(1)+sz(1)*0.4,orig(2)+sz(2)*0.2,sz(1)*0.2,sz(2)*0.19,0,23040,color=color(0,0,0),background=color(191,0,0),thickness=0.5);
    else
      xarc(orig(1)+sz(1)*(1-0.4-0.2),orig(2)+sz(2)*0.2,sz(1)*0.2,sz(2)*0.19,-11520,23040,color=color(0,0,0),background=color(191,0,0),thickness=0.5);
    end
    if orient then
      xrect(orig(1)+sz(1)*0.44,orig(2)+sz(2)*0.7,sz(1)*0.12,sz(2)*0.54,color=color(191,0,0),background=color(191,0,0),thickness=0.25);
    else
      xrect(orig(1)+sz(1)*(1-0.44-0.12),orig(2)+sz(2)*0.7,sz(1)*0.12,sz(2)*0.54,color=color(191,0,0),background=color(191,0,0),thickness=0.25);
    end
    xpoly(xx+ww*[0.56;1],yy+hh*[0.5;0.5],color=color(0,0,255),thickness=0.25);
    xpoly(xx+ww*[0;0.44],yy+hh*[0.5;0.5],color=color(191,0,0),thickness=0.25);
    xpoly(xx+ww*[0.44;0.44;0.45;0.47;0.5;0.53;0.55;0.56;0.56;0.44],yy+hh*[0.7;0.9;0.93;0.94;0.95;0.94;0.93;0.9;0.7;0.7],color=color(0,0,0),thickness=0.5);
    xpoly(xx+ww*[0.44;0.44],yy+hh*[0.7;0.18],color=color(0,0,0),thickness=0.5);
    xpoly(xx+ww*[0.56;0.56],yy+hh*[0.7;0.18],color=color(0,0,0),thickness=0.5);
    xpoly(xx+ww*[0.3;0.44],yy+hh*[0.4;0.4],color=color(0,0,0),thickness=0.25);
    xpoly(xx+ww*[0.3;0.44],yy+hh*[0.6;0.6],color=color(0,0,0),thickness=0.25);
    xpoly(xx+ww*[0.3;0.44],yy+hh*[0.8;0.8],color=color(0,0,0),thickness=0.25);
    if orient then
      xstring(orig(1)+sz(1)*0.63,orig(2)+sz(2)*-0.1,"C",w=sz(1)*0.5,h=sz(2)*0.5,fill=%t,color=color(0,0,0));
    else
      xstring(orig(1)+sz(1)*(-0.13),orig(2)+sz(2)*-0.1,"C",w=sz(1)*0.5,h=sz(2)*0.5,fill=%t,color=color(0,0,0));
    end
    if orient then
      xstring(orig(1)+sz(1)*-0.16,orig(2)+sz(2)*0.92,model.label,w=sz(1)*1.2,h=sz(2)*0.3,fill=%t,color=color(0,0,255));
    else
      xstring(orig(1)+sz(1)*(-0.04),orig(2)+sz(2)*0.92,model.label,w=sz(1)*1.2,h=sz(2)*0.3,fill=%t,color=color(0,0,255));
    end
  endfunction

x=[];y=[];typ=[];

select job
  case 'plot' then
    standard_draw(arg1,%f,_CTHS_TemperatureSensor_dp);
  case 'getinputs' then
    [x,y,typ]=_CTHS_TemperatureSensor_ip(arg1);
  case 'getoutputs' then
    [x,y,typ]=_CTHS_TemperatureSensor_op(arg1);
  case 'getorigin' then
    [x,y]=standard_origin(arg1);
  case 'set' then
    x=arg1;
  case 'define' then
    model=scicos_model();
    model.sim='Coselica';
    model.blocktype='c';
    model.dep_ut=[%t %f];
    model.in=[1];
    model.out=[1];
    mo=modelica();
      mo.model='Coselica.Thermal.HeatTransfer.Celsius.TemperatureSensor';
      mo.inputs=['port'];
      mo.outputs=['T'];
      mo.parameters=list([],list(),[]);
    model.equations=mo;
    exprs=[];
    gr_i="blk_draw(sz,orig,orient,model.label)";
    x=standard_define([2 2],model,exprs,list(gr_i,0));
    x.graphics.in_implicit=['I'];
    x.graphics.out_implicit=['E'];
  end
endfunction
