// Coselica Toolbox for Scicos/Nsp
// Copyright (C) 2009-2016  Dirk Reusch, Kybernetik Dr. Reusch
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

function [x,y,typ]=CTHS_PrescribedTemperature(job,arg1,arg2)

  function blk_draw(sz,orig,orient,label)
    if orient then
      xx=orig(1);yy=orig(2);
      ww=sz(1);hh=sz(2);
    else
      xx=orig(1)+sz(1);yy=orig(2);
      ww=-sz(1);hh=sz(2);
    end
    if orient then
      xrect(orig(1)+sz(1)*0,orig(2)+sz(2)*1,sz(1)*1,sz(2)*1,color=color(0,0,0),background=color(159,159,223),thickness=0.25);
    else
      xrect(orig(1)+sz(1)*(1-0-1),orig(2)+sz(2)*1,sz(1)*1,sz(2)*1,color=color(0,0,0),background=color(159,159,223),thickness=0.25);
    end
    xpoly(xx+ww*[-0.01;0.82],yy+hh*[0.5;0.5],color=color(191,0,0),thickness=0.5);
    if orient then
      xstring(orig(1)+sz(1)*0,orig(2)+sz(2)*0,"K",w=sz(1)*0.5,h=sz(2)*0.5,fill=%t,color=color(0,0,0));
    else
      xstring(orig(1)+sz(1)*(0.5),orig(2)+sz(2)*0,"K",w=sz(1)*0.5,h=sz(2)*0.5,fill=%t,color=color(0,0,0));
    end
    if orient then
      xstring(orig(1)+sz(1)*-0.125,orig(2)+sz(2)*1.01,model.label,w=sz(1)*1.2,h=sz(2)*0.3,fill=%t,color=color(0,0,255));
    else
      xstring(orig(1)+sz(1)*(-0.075),orig(2)+sz(2)*1.01,model.label,w=sz(1)*1.2,h=sz(2)*0.3,fill=%t,color=color(0,0,255));
    end
    xfpoly(xx+ww*[0.75;0.75;0.95;0.75],yy+hh*[0.4;0.6;0.5;0.4],color=color(191,0,0),fill_color=color(191,0,0),thickness=0.25);
  endfunction

x=[];y=[];typ=[];

select job
  case 'plot' then
    standard_draw(arg1,%f,_CTHS_PrescribedTemperature_dp);
  case 'getinputs' then
    [x,y,typ]=_CTHS_PrescribedTemperature_ip(arg1);
  case 'getoutputs' then
    [x,y,typ]=_CTHS_PrescribedTemperature_op(arg1);
  case 'getorigin' then
    [x,y]=standard_origin(arg1);
  case 'set' then
    x=arg1;
  case 'define' then
    model=scicos_model();
    model.sim='Coselica';
    model.blocktype='c';
    model.dep_ut=[%t %f];
    model.in=[1];
    model.out=[1];
    mo=modelica();
      mo.model='Coselica.Thermal.HeatTransfer.Sources.PrescribedTemperature';
      mo.inputs=['T'];
      mo.outputs=['port'];
      mo.parameters=list([],list(),[]);
    model.equations=mo;
    exprs=[];
    gr_i="blk_draw(sz,orig,orient,model.label)";
    x=standard_define([2 2],model,exprs,list(gr_i,0));
    x.graphics.in_implicit=['E'];
    x.graphics.out_implicit=['I'];
  end
endfunction
