// Coselica Toolbox for Scicos/Nsp
//
// Original Scicoslab version
//   Copyright (C) INRIA
//
// Modifications for Nsp
//   Copyright (C) 2013 Dirk Reusch, Kybernetik Dr. Reusch
//
// get a color from the current colormap
// or add it to current colormap if it does not exist
//
function id=color(c1,c2,c3)

  rhs = nargin;

  if rhs==1 then 
    if type(c1, "short") <> "s" | size(c1,"*")<>1 then
      error("color: argument must be a string")
    else
      c=name2rgb(c1);
      if c==[] then
        error("color: """ + c1 + """ is not a known color")
      end
      c=c/255;
    end
  elseif rhs==3 then
    if ~isreal(c1) | ~isreal(c2) | ~isreal(c3) | size(c1,"*")<>1 | size(c2,"*")<>1 | size(c3,"*")<>1 then
      error("color: arguments must be integers")
    end
    if (c1>255 | c1<0 | c2>255 | c2<0 | c3>255 | c3<0) then
      error("color: arguments must be integers between 0 and 255")
    end
    c=[c1,c2,c3]/255;
  else
    error("color: expecting 1 or 3 arguments")
  end

//  if ~new_graphics() then
    cmap=xget("colormap");
//  else
//    f=get_current_figure();
//    cmap=f.gc.colormap;
//  end

  ncol=max(size(cmap,"r"));
  if ncol > 0 then
    k = find(abs(cmap-ones(ncol,1)*c)*ones(3,1)<=1.d-5);
  else
    k = [];
  end

  if isempty(k) then
    // color does not exist, add it
    cmap=[cmap;c];
    id=ncol+1;
//    if ~new_graphics() then
      xset("colormap",cmap);
//    else
//      f.gc.colormap = cmap;
//    end
  else
    id=k(1);
  end

endfunction
