function H1=coselica_palettes()
  // returns a H table of scicos default palette
  H1 = hash(10);

  // describe the structure of the palette hierarchy.
//  H1.structure= list('Blocks','Electrical','Mechanics','Heat Transfer','Obsolete');
  H1.structure= list('Blocks','Electrical','Mechanics','Heat Transfer');
  
  // for each palette describe its contents

  // Blocks (Begin)
  H_blocks=hash(10);
  H_blocks.structure=list('Interfaces','Routing','Math','Math Vectors','Sources','Continuous','Non-Linear');

  H=hash(10);
  
  // Blocks/Interfaces
  H('Interfaces') = list('CBI_RealInput',
                         'CBI_RealOutput');
  // Blocks/Routing
  H('Routing') = list('CBR_DeMultiplex2',
                      'CBR_Multiplex2',
                      'CBR_Replicator',
                      'CBR_Extractor',
                      'CBR_DeMultiplexVector2',
                      'CBR_MultiplexVector2');
  
  // Blocks/Math
  H('Math')=list('CBM_Gain',
                'CBM_Feedback',
                'CBM_Add',
                'CBM_Add3',
                'CBM_Product',
                'CBM_Division',
                'CBM_Min',
                'CBM_Max',
                'CBM_Abs',
                'CBM_Sign',
                'CBM_Sqrt',
                'CBM_Exp',
                'CBM_Log',
                'CBM_Log10',
                'CBM_Sin',
                'CBM_Cos',
                'CBM_Tan',
                'CBM_Asin',
                'CBM_Acos',
                'CBM_Atan',
                'CBM_Atan2',
                'CBM_Sinh',
                'CBM_Cosh',
                'CBM_Tanh',
                'CBM_TwoInputs',
                'CBM_TwoOutputs');

  // Blocks/Math/Vectors FIXME
  H('Math Vectors')=list('CBM_Sum',
                         'CBMV_Add',
                         'CBMV_DotProduct',
                         'CBMV_ElementwiseProduct',
                         'CBMV_CrossProduct');

  // Blocks/Sources
  H('Sources')=list('CBS_Clock',            
                    'CBS_Constant',
                    'CBS_Step',
                    'CBS_Ramp',
                    'CBS_Sine',
                    'CBS_ExpSine',
                    'CBS_Exponentials',
                    'CBS_Pulse',
                    'CBS_SawTooth',
                    'CBS_Trapezoid');

  // Blocks/Continuous
  H('Continuous')=list('CBC_Integrator',
                        'CBC_LimIntegrator',
                        'CBC_Der',
                        'CBC_Derivative',
                        'CBC_FirstOrder',
                        'CBC_SecondOrder',
                        'CBC_PI',
                        'CBC_PID',
                        'CBC_LimPID');

  // Blocks/Nonlinear
  H('Non-Linear')=list('CBN_Limiter',
                        'CBN_DeadZone',
                        'CBN_Hysteresis',
                        'CBN_RateLimiter');

  // Blocks (End)
  H_blocks.contents=H

  // Electrical (Begin)
  H_elec=hash(10);
  H_elec.structure=list('Basic','Ideal','Semiconductors','Sensors','Sources','Multiphase');

  H=hash(10);

  // Electrical/Basic
  H('Basic')=list('CEAB_Ground',
                  'CEAB_NotConnected',
                  'CEAB_Resistor',
                  'CEAB_HeatingResistor',
                  'CEAB_Capacitor',
                  'CEAB_Inductor',
                  'CEAB_Transformer',
                  'CEAB_Gyrator',
                  'CEAB_EMF0',
                  'CEAB_EMF',
                  'CEAB_TranslationalEMF0',
                  'CEAB_TranslationalEMF',
                  'CEAB_VCV',
                  'CEAB_VCC',
                  'CEAB_CCV',
                  'CEAB_CCC',
                  'CEAB_OpAmp',
                  'CEAB_VariableResistor',
                  'CEAB_VariableCapacitor',
                  'CEAB_VariableInductor');

  // Electrical/Ideal
  H('Ideal')=list('CEAI_IdealOpAmp',
                   'CEAI_IdealOpAmp3Pin',
                   'CEAI_IdealOpAmpLimited',
                   'CEAI_IdealDiode',
                   'CEAI_IdealTransformer',
                   'CEAI_IdealGyrator',
                   'CEAI_Idle',
                   'CEAI_Short',
                   'CEAI_IdealOpeningSwitch',
                   'CEAI_IdealClosingSwitch',
                   'CEAI_IdealIntermediateSwitch',
                   'CEAI_IdealCommutingSwitch');

  // Electrical/Semiconductors
  H('Semiconductors')=list('CEAS_Diode',
                           'CEAS_ZDiode',
                           'CEAS_PMOS',
                           'CEAS_NMOS',
                           'CEAS_NPN',
                           'CEAS_PNP',
                           'CEAS_Thyristor');

  // Electrical/Sensors
  H('Sensors')=list('CEAS_PotentialSensor',
                     'CEAS_VoltageSensor',
                     'CEAS_CurrentSensor',
                     'CEAS_PowerSensor');

  // Electrical/Sources
  H('Sources')=list('CEAS_SignalVoltage',
                     'CEAS_ConstantVoltage',
                     'CEAS_StepVoltage',
                     'CEAS_RampVoltage',
                     'CEAS_SineVoltage',
                     'CEAS_PulseVoltage',
                     'CEAS_SawToothVoltage',
                     'CEAS_TrapezoidVoltage',
                     'CEAS_SignalCurrent',
                     'CEAS_ConstantCurrent',
                     'CEAS_StepCurrent',
                     'CEAS_RampCurrent',
                     'CEAS_SineCurrent',
                     'CEAS_PulseCurrent',
                     'CEAS_SawToothCurrent',
                     'CEAS_TrapezoidCurrent');
  
  H('Multiphase') = coselica_palettes_electrical_multiphase();
  
  // Electrical (End)
  H_elec.contents=H

  // Mechanics (Begin)
  H_mech=hash(10);
  H_mech.structure= list('Translational','Rotational','Planar');

  //Mechanics/Translational (Begin)
  H_trans = hash(10);
  H_trans.structure= list('Components', 'Sources', 'Sensors');

  H=hash(10);

  H('Components')=list('CMTC_Fixed',
                       'CMTC_Free',
                       'CMTC_Mass',
                       'CMTC_MassWithWeight',
                       'CMTC_Rod',
                       'CMTC_Spring',
                       'CMTC_Damper',
                       'CMTC_SpringDamper',
                       'CMTC_ElastoGap',
                       'CMTC_MassWithFriction',
                       'CMTC_Stop',
                       'CMTC_Pulley',
                       'CMTC_ActuatedPulley',
                       'CMTC_Lever');

  H('Sources')=list('CMTS_Position0',
                    'CMTS_Speed0',
                    'CMTS_Accelerate0',
                    'CMTS_Force0',
                    'CMTS_Position',
                    'CMTS_Speed',
                    'CMTS_Accelerate',
                    'CMTS_Force',
                    'CMTS_Force2',
                    'CMTS_ConstantForce',
                    'CMTS_ConstantSpeed',
                    'CMTS_ForceStep',
                    'CMTS_LinearSpeedDependentForce',
                    'CMTS_QuadraticSpeedDependentForce');

  H('Sensors')=list('CMTS_PositionSensor',
                    'CMTS_SpeedSensor',
                    'CMTS_AccSensor',
                    'CMTS_RelPositionSensor',
                    'CMTS_RelSpeedSensor',
                    'CMTS_RelAccSensor',
                    'CMTS_ForceSensor',
                    'CMTS_PowerSensor');

  // //Mechanics/Translational (End)
  H_trans.contents=H;

  // Mechanics/Rotational (Begin)
  H_rot = hash(10);
  H_rot.structure= list('Components', 'Sources', 'Sensors');

  H=hash(10);

  H('Components')=list('CMRC_Fixed',
                       'CMRC_Free',
                       'CMRC_Inertia',
                       'CMRC_Disc',
                       'CMRC_Spring',
                       'CMRC_Damper',
                       'CMRC_SpringDamper',
                       'CMRC_ElastoBacklash',
                       'CMRC_BearingFriction',
                       'CMRC_Brake',
                       'CMRC_Clutch',
                       'CMRC_OneWayClutch',
                       'CMRC_Freewheel',
                       'CMRC_IdealGear',
                       'CMRC_IdealPlanetary',
                       'CMRC_IdealDifferential',
                       'CMRC_IdealGearR2T');

  H('Sources')=list('CMRS_Position0',
                    'CMRS_Speed0',
                    'CMRS_Accelerate0',
                    'CMRS_Torque0',
                    'CMRS_Position',
                    'CMRS_Speed',
                    'CMRS_Accelerate',
                    'CMRS_Torque',
                    'CMRS_Torque2',
                    'CMRS_ConstantTorque',
                    'CMRS_ConstantSpeed',
                    'CMRS_TorqueStep',
                    'CMRS_LinearSpeedDependentTorque',
                    'CMRS_QuadraticSpeedDependentTorque');

  H('Sensors')=list('CMRS_AngleSensor',
                    'CMRS_SpeedSensor',
                    'CMRS_AccSensor',
                    'CMRS_RelAngleSensor',
                    'CMRS_RelSpeedSensor',
                    'CMRS_RelAccSensor',
                    'CMRS_TorqueSensor',
                    'CMRS_PowerSensor');

  // Mechanics/Rotational (End)
  H_rot.contents=H;

  //Mechanics->Planar
  H_plan = hash(10);
  H_plan.structure= list('World','Forces','Joints','LoopJoints','Parts','Sensors');

  //Mechanics->Planar->Sensors
  H_plan_sens = hash(10);
  H_plan_sens.structure= list('Sensors','Absolute Sensors','Relative Sensors');

  H=hash(10);
  H('Sensors')=list('CMPS_Distance',
                    'CMPS_CutForce',
                    'CMPS_CutForce2',
                    'CMPS_CutTorque',
                    'CMPS_Power');

  H('Absolute Sensors')=list('CMPSA_Position',
                              'CMPSA_Velocity',
                              'CMPSA_Acceleration',
                              'CMPSA_Angle',
                              'CMPSA_AngularVelocity',
                              'CMPSA_AngularAcceleration',
                              'CMPSA_Position2',
                              'CMPSA_Velocity2',
                              'CMPSA_Acceleration2');

  H('Relative Sensors')=list('CMPSR_Position',
                              'CMPSR_Velocity',
                              'CMPSR_Acceleration',
                              'CMPSR_Angle',
                              'CMPSR_AngularVelocity',
                              'CMPSR_AngularAcceleration',
                              'CMPSR_Position2',
                              'CMPSR_Velocity2',
                              'CMPSR_Acceleration2');

  H_plan_sens.contents=H;

  H=hash(10);

  H('World')= list('CMP_World');

  H('Forces')=list('CMPF_WorldForce',
                   'CMPF_WorldTorque',
                   'CMPF_FrameForce',
                   'CMPF_LineForce',
                   'CMPF_LineForceWithMass');

  H('Joints')=list('CMPJ_FreeMotion',
                   'CMPJ_Prismatic',
                   'CMPJ_Revolute',
                   'CMPJ_ActuatedPrismatic',
                   'CMPJ_ActuatedRevolute',
                   'CMPJ_RollingWheel',
                   'CMPJ_ActuatedRollingWheel');

  H('LoopJoints')=list('CMPL_Prismatic',
                       'CMPL_Revolute',
                       'CMPL_ActuatedPrismatic',
                       'CMPL_ActuatedRevolute');

  H('Parts')=list('CMPP_Fixed',
                  'CMPP_FixedTranslation',
                  'CMPP_FixedRotation',
                  'CMPP_Body',
                  'CMPP_BodyShape',
                  'CMPP_PointMass');

  H('Sensors')=H_plan_sens;

  H_plan.contents=H;

  H=hash(10);

  H('Translational')= H_trans;

  H('Rotational')=H_rot;

  H('Planar')=H_plan;

  H_mech.contents=H;

  //Heat Transfer
  H_heat=hash(10);
  H_heat.structure=list('Components','Sources','Sensors','Celcius');

  H=hash(10);

  H('Components')=list('CTHC_HeatCapacitor',
                       'CTHC_ThermalConductor',
                       'CTHC_Convection',
                       'CTHC_BodyRadiation');

  H('Sources')=list('CTHS_FixedTemperature',
                    'CTHS_PrescribedTemperature',
                    'CTHS_FixedHeatFlow',
                    'CTHS_PrescribedHeatFlow');

  H('Sensors')=list('CTHS_TemperatureSensor',
                    'CTHS_RelTemperatureSensor',
                    'CTHS_HeatFlowSensor');

  H('Celcius')=list('CTHC_ToKelvin',
                    'CTHC_FromKelvin',
                    'CTHC_FixedTemperature',
                    'CTHC_PrescribedTemperature',
                    'CTHC_TemperatureSensor');

  H_heat.contents=H;

  H=hash(10);
  H('Blocks')=H_blocks
  H('Electrical')=H_elec
  H('Mechanics')=H_mech
  H('Heat Transfer')=H_heat
  
//  H('Obsolete')=list('MMT_SlidingMass','CMT_Position','CMT_Speed','MMT_Accelerate',...
//                     'MMT_Force','MEAB_EMF','CMR_Position','CMR_Speed','MMR_Accelerate',...
//                     'MMR_Torque','MMR_Torque2','MMR_ConstantTorque','MMR_ConstantSpeed',...
//                     'MMR_TorqueStep','MMR_LinearSpeedDependent','MMR_QuadraticSpeedDepend');

  H1.contents = H;

endfunction


function [P] = coselica_palettes_electrical_multiphase()
  
  P = hash(10);
  P.structure = list('Basic','Ideal','Sensors','Sources');
  
  C = hash(10);
  C('Basic') = list( 'CEMB_PlugToPin_p',
                      'CEMB_PlugToPin_n',
                      'CEMB_Star',
                      'CEMB_Delta',
                      'CEMB_Resistor',
                      'CEMB_Capacitor',
                      'CEMB_Inductor',
                      'CEMB_Transformer' );
                      
  C('Ideal') = list( 'CEMI_IdealDiode',
                      'CEMI_IdealTransformer',
                      'CEMI_Idle',
                      'CEMI_Short',
                      'CEMI_IdealOpeningSwitch',
                      'CEMI_IdealClosingSwitch',
                      'CEMI_IdealCommutingSwitch',
                      'CEMI_IdealIntermediateSwitch' );
                      
  C('Sensors') = list( 'CEMS_PotentialSensor',
                        'CEMS_VoltageSensor',
                        'CEMS_CurrentSensor',
                        'CEMS_PowerSensor' );
                        
  C('Sources') = list( 'CEMS_SignalVoltage',
                        'CEMS_ConstantVoltage',
                        'CEMS_SineVoltage',
                        'CEMS_SignalCurrent',
                        'CEMS_ConstantCurrent',
                        'CEMS_SineCurrent' );
  P.contents = C;
  
endfunction

//
function scmenu_coselica_palettes()
  Cmenu=''
  scicos_widgets($+1)=hash(id=scicos_palette_icon_view(coselica_palettes()),open=%t,what='IconView');
endfunction


