// Coselica Toolbox for Scicos/NSP
// Copyright (C) 2016  Dirk Reusch, Kybernetik Dr. Reusch
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

function [ nobs, hobs, scs_m_new ] = do_fix_import( scs_m, hilite )
    
    nobs = 0;  // number of fixed blocks
    hobs = []; // object indices for highlighting
    
    scs_m_new = scs_m;
    
    objs = scs_m.objs;
    for i = 1:length(objs) do
        if objs(i).type == 'Block' then
            o = objs(i);
            //printf('Check Block: %s\n',o.gui);
            if o.gui == 'SUPER_f' then
		        	[ nn, hh ] = do_fix_import( o.model.rpar, %f );
		            if nn > 0 then
		                nobs = nobs + nn;
		                if hilite <> %f then
		                  hobs($+1) = i; // hilite fixed super block
		               end
		            end
            else
            	if (typeof(o.model.sim)=='s')&&(o.model.sim=='Coselica') then
            		//printf('Check Coselica Block: %s\n',o.gui)
            		fixed = %f;
            		im = o.graphics.in_implicit;
            		ni = numel(im);
            		if (ni > 1)&&(numel(unique(im)) > 1) then
            			scs_m_new.objs(i).graphics.in_implicit = smat_create(ni,1,'I');
            			fixed = %t;
            		end
            		im = o.graphics.out_implicit;
            		ni = numel(im);
            		if (ni > 1)&&(numel(unique(im)) > 1) then
            			scs_m_new.objs(i).graphics.out_implicit = smat_create(ni,1,'I');
            			fixed = %t;
            		end
            		if fixed then
              		//printf('Fixed Coselica Block: %s\n',o.gui)
            			nobs = nobs + 1;
            			if hilite <> %f then
                    hobs($+1) = i; // hilite fixed block
                  end
            		end
            	end
            end
        end
    end

endfunction
